<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_APB);

new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends GenIntField
    { public $name = 'NUM'; 
 	  public $data= true;
    },
    new class extends StringField
    { public $name = 'ZONENAME';
      public $caption = ' ';  
	  public $required = false;
    },
    new class extends BoolField
    { public $name = 'ENABLED'; 
    },
    new class extends BoolField
    { public $name = 'ON_ENTER'; 
    },
    new class extends BoolField
    { public $name = 'ON_EXIT'; 
    }, 
    new class extends IntField
    { public $name = 'DEBLOCK_TIME'; 
      public $default=0; 
    }, 
    new class extends IntField
    { public $name = 'EXCEPT_GROUPS'; 
    }	
  ];   
  
  $this->set_visible(['ZONENAME']);

  
  $this->select_sql ='select * from TER_ZONES '.sql_where(' where num',RT_TZ).' order by zonename';   
  $this->refresh_sql='select * from TER_ZONES where num=:num';

  $this->update_sql =  "update D_APB set   
                        enabled = :enabled,  
						on_enter = :on_enter,  
						on_exit = :on_exit,  
						deblock_time = :deblock_time,  
						except_groups = :except_groups
                        where ter_zone = :num";
						
  $this->insert_sql =  "insert into D_APB( ter_zone,  enabled,   on_enter,   on_exit,   deblock_time,    except_groups)
                        values  (:num,    :enabled,    :on_enter,    :on_exit,    :deblock_time,    :except_groups)";

 }
 
 
 function before_update($params)
 { 
   if(!$this->prepare_execute("select * from D_APB where ter_zone=:num", $params)->fetch())
     $this->update_sql = $this->insert_sql;
 }
 
 function update_also($params)
 { 
   $a=$this->prepare_execute("select group_ref from D_APB_GROUPS where ter_zone=:num",$params)->fetchAll(PDO::FETCH_COLUMN);
   $b=array_keys($params['G']);
  
   foreach(array_diff($a, $b) as $g)
     $this->prepare_execute("delete from D_APB_GROUPS where group_ref=$g and ter_zone=:num", $params);
	 
   foreach(array_diff($b, $a) as $g)
     $this->prepare_execute("insert into D_APB_GROUPS (ter_zone, group_ref) values (:num, $g)", $params);
 }
 
}; //TDataset 