<?php

class O_NUMBERField extends IntField
{
 public $default=0;
 
 function draw_text($value, $row) 
  { if($value) echo $value;  }
}
//---------------------------------------------------------

class CardCodeField extends StringField
{ 
 public static $card_code_format; //autoinit
 public $size=12;	  
 public $default='';
 
 private function RS_to_EL($num, $seria)
 {
  if(is_null(self::$card_code_format))
    self::$card_code_format = $this->dataset->db->query('select card_code_format from D_SETTINGS')->fetchColumn();   
 
  $num  |= ($seria & 0xff) << 16;
  if(self::$card_code_format==0)
  {
   $p1=0;
   for($i=0; $i<12; $i++) if($num & 1<<$i) $p1++;
   $p2=0;
   for($i=12; $i<24; $i++) if($num & 1<<$i) $p2++;

   $num |= ($p2 & 1)<<24;
   $num <<= 1;
   $num |= ~$p1 & 1;
  }
  return strtoupper(dechex($num));
 }


  function parse($v)
  {
	 $np=explode(',',$v,2);
	 
	 if(count($np)==2)
	    if(ctype_digit($np[0]) && ctype_digit($np[1]))
      	      return $this->RS_to_EL(intval($np[1]), intval($np[0]));
	    else  throw new Exception("   / ");	 	 
	 else
	    if($v && !ctype_xdigit($v)) 
	           throw new Exception("    ");
    	  else return ltrim(strtoupper($v),'0');     		 
  }	  
  
  
  function validate_also($v)
  {
    if(!$v) return;
	$sql = isset($this->card_type) ?
	       "select u.username from USERS u,D_OWNER_CARDS c where c.card_code=:card_code and u.num!=:num and u.num=c.user_ref and c.card_type=$this->card_type" :
		   "select u.username from USERS u,D_OWNERS o where u.num=o.user_ref and o.card_code=:card_code and u.num!=:num";

	$q=$this->dataset->prepare_execute($sql, ['card_code' => $v, 
                                     	       'num'      => $this->dataset->params['num'] ?? 0]);

	if($name=$q->fetchColumn())
	  throw new Exception("$this->caption    $name");
  }  
};	
 