<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_HARDWARE);

new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'COMPUTER'; 
      public $caption = '';
 	  public $data= true;
	  public $names =['update' => 'NEWID'];
    },
    new class extends StringField
    { public $name = 'NAME';
      public $caption = '';  
  	  public $size=64;	  
    },	
    new class extends StringField
    { public $name = 'INETADDR';
      public $caption = 'IP ';  
  	  public $size=16;	  

      function make_edit_attr(&$at)
	  { $at['minlength']=7;
	    $at['placeholder']='0.0.0.0';
		$at['pattern']='^([0-9]{1,3}\.){3}[0-9]{1,3}$'; 
 	  }	  
	  
      function validate_also($v) 
	  { if(!ip2long($v)) throw new Exception(" $this->caption");  }	  
    },	
  ];   

  $this->select_sql ='select * from COMPUTERS order by computer';   
  
  $this->refresh_sql='select * from COMPUTERS  where computer=:computer';
  
  $this->delete_sql = ['delete from COMPUTERS  where computer=:computer',
                       'delete from D_COMMANDS where executor=:computer'];
					   
  $this->update_sql ='update COMPUTERS set computer=:newid, name=:name, inetaddr=:inetaddr where computer=:computer';
  
  $this->insert_sql ='insert into COMPUTERS (computer, name, inetaddr) values (:computer, :name, :inetaddr)'; 
 }
 
protected $error_map = 
	['COMPUTERSPRIMARYKEY' => '    ', 
	 'FOREIGN KEY' => ' '];  
 
 
 }; //TDataset 