<?php

class TDataBase extends PDO
{
 public $autocommit=true;

 public function __construct($dbname,$username,$password)
 { 
   parent::__construct($dbname,$username,$password, [PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION,  
                                                     PDO::ATTR_PERSISTENT => true, 
													 PDO::ATTR_AUTOCOMMIT=> false,
													 PDO::ATTR_CASE => PDO::CASE_UPPER
													]);
   parent::beginTransaction(); 
 }
 
 public function __destruct()
 { 
   if(parent::inTransaction())  
    if($this->autocommit) parent::commit(); 
   	                 else parent::rollBack(); 
   //parent::__destruct(); no such method
 }
 
//     $params,    null 
//   
//   @    (   ).
// statement
function prepare_execute($s, $params)
{
 $params=array_change_key_case($params,CASE_LOWER);

 $len=strlen($s);
 $par=[]; //extracted params
 for($i=0; $i<$len; )
  switch($s[$i])
  { case '@':
    case ':': $i0=$i++;
              while($i<$len && (ctype_alnum($s[$i]) || $s[$i]=='_')) $i++;			  
			  if($s[$i0]==':')
			       {$pn=substr($s, $i0+1, $i-$i0-1);
     			    //$par[$pn]=$params[strtolower($pn)] ?? null;	//sql param
					$par[]=$params[strtolower($pn)] ?? null;
			        $s=substr_replace($s, '?', $i0, $i-$i0);   
			        $i=$i0+1;
				    $len=strlen($s);
				   }	
			  else {$pn=substr($s, $i0, $i-$i0);
			        $s=substr_replace($s, $params[strtolower($pn)] ?? '', $i0, $i-$i0);   //macro  
			        $i=$i0;
				    $len=strlen($s);
				   }	
			  //if(is_null($par[$pn])) throw new Exception($pn.' is null !!!');
			  break;
			  
			  

    case "'": case "\"":
          $i0=$i++;
		  while($i<$len && $s[$i]!=$s[$i0]) $i++;
		  $i++;		  
          break; 
		  
    case '/': //comment
           if($s[++$i]=='*')
		   { $i++;
		     while($i+1<$len && $s[$i]!='*' && $s[$i+1]!='/') $i++;
			 $i+=2;
		   }	
           break;      
  
    default: $i++;
  } 
 $q=$this->prepare($s);
 $q->execute($par);
 return $q;
}
} //TDataBase

//=======================================================================================

class FBDataBase extends TDataBase //     FB
{
 //    
 function gen_id($generator, $inc=1)
 { return $this->query("select gen_id($generator, $inc) from rdb\$database")->fetchColumn(); }

 public function __construct($dbhost,$dbname,$username,$password)
 { if($dbhost) $dbhost.=':';
   parent::__construct("firebird:dbname=$dbhost$dbname;charset=none;dialect=1;", $username,$password); } 
}

//======================================================================================= 