<?php
class TField
{ //        . 
  public $name;  
  // : int/string
  public $type='string';
  // 
  public $caption;
  //  (hint  )
  public $title;
  //   tr.dataset 
  public $data=false; 
  //   
  public $visible=true;
  //  (       )
  //  = !$visible
  //  = false,      insert  update
  public $readonly;
  //  ()
  public $required=true;
  //     ,      null 
  public $default; 

  //         
  //            
  //            !
  //     
  //    : 'action' => 'name'
  //  $name   '*' => $name 
  public $names=[];
  
  //         
  public $th_class=[];
  //.  .    th 
  public $th_attr=[];
  // .       select
  public $key=false;
  
  public $dataset; //  ,    ( )
  public $index;   //     ( )
  
  //.    td        
  public $td_class=[];  
  //       
  function get_classes($value, $row)  { return []; }
  
  public $extra_caption; //  
  public $extra_colspan=1; //-     . 		
  public $extra_attr=[];   //    th  
  
  //   ,     .
  function get_default($action)
  { return $this->default; }
  
  function draw_head_text()
  { echo htmlspecialchars($this->caption ?? $this->name);  }
  
  //  
  function draw_head()
  { echo "<th";
    draw_html_attr($this->th_attr);
    if(isset($this->title)) echo ' title="', htmlspecialchars($this->title), '"';	
	echo ' class="',$this->name;
    if($this->th_class) echo ' ',implode(' ', $this->th_class);
	echo '"><span>'; $this->draw_head_text(); echo '</span>';
	echo '</th>',"\r\n"; 
  }
  
  // . 
  function draw_extra_head()
  { draw_html_tag('th', ($this->extra_attr ?? []) + ['colspan'=>$this->extra_colspan] , $this->extra_caption); echo "\r\n";  }  

  //  
  function draw_col()  { echo "<col class='$this->name'>\r\n"; }  
  
  
  //  
  function draw_text($value, $row)    { echo htmlspecialchars($value ?? ''); }
  
  //       data-*
  function get_data_text($value) { return $value; }
  
  //     style
  function get_styles($value, $row)  { return []; }
  
  //  
  function draw($value, $row)
  {
    echo "<td class='$this->name";
	foreach($this->td_class as $c)
	  echo ' ',$c; 
	foreach($this->get_classes($value, $row) as $c)
	  echo ' ',$c; 
	echo "'";  
	  
    if($st=$this->get_styles($value, $row))
   	  echo ' style="',implode(';', $st),'"';  
  
    echo ">", $this->draw_text($value, $row), "</td>";
  }

  //    ,   -     
  function get_name($action)
  { return $this->names[$action] ??
           $this->names['*'];  }
  

  //      
  function draw_edit_text($value, $row)   { $this->draw_text($value, $row); }
  
  //    ( value)   <input>  
  function make_edit_attr(&$at){}
  
  //     , $action -       'insert'  'update'
  function draw_editor($value, $row, $action)  
  { if($this->readonly ?? false) $this->draw($value, $row);
    else
	{
      echo '<td class=inplace>';
	  echo '<input';
	  $at=[ 'name'=> $this->get_name($action)];
	  if($this->required)  $at['required'] =null; 
	  $this->make_edit_attr($at);
	  draw_html_attr($at);
	  echo ' value="',$this->draw_edit_text($value, $row),'"';	
      echo '></td>';
    }		 
  }

  
  //   ,   - 
  function parse($v)
  { return $v!='' ? $v :  null;  }  
  
  //     . 
  //       ,   -   parse
  function parse_array($v)
  { $res=[];
    foreach($v as $key=>$value)
	{
      $k=filter_var($key,  FILTER_VALIDATE_INT);
      if($k===false) throw new Exception("    : $key");
	  $res[$k] = $this->parse($value);
	}  
    return $res;  
  }
  
  //      ,   
  function validate($v)
  { if(is_null($v) && $this->required) throw new Exception(" '".($this->title ?? $this->caption ?? $this->name)."'    ");
    $this->validate_also($v);	 
  }
  //      
  function validate_params($params, $action)
  { $value=$params[$this->get_name($action)] ?? null;
    if(is_array($value))
	  foreach($value as $v)
  	     $this->validate($v); 
	else $this->validate($value); 
  }  
  
  //    
  function validate_also($v) { }
 
  //     .       .
  function restrict($v, $action) {}
 
  //      ,  $dir = 'asc'|'desc'
  function get_sort_expr($dir)
  { return $this->name.' '.$dir; }  
} //TField
//----------------------------------------------------------------

class IntField extends TField
{ public $type='int';
  //     int
  public $min=0;
  public $max=null;    
 
  function make_edit_attr(&$at)
  { $at['type']='number';
    if(!is_null($this->min)) $at['min']=$this->min;
	if(!is_null($this->max)) $at['max']=$this->max;    
  }
  
  function parse($s)
  { if($s=='') return null;
    $v=filter_var($s,  FILTER_VALIDATE_INT);
	if($v===false) throw new Exception("    : $s");
    return $v;
  }

  function validate($v)
  { parent::validate($v);
    if(!is_null($this->min) && $v<$this->min || !is_null($this->max) && $v>$this->max) 
	  throw new Exception("   '$this->caption' ");
  }      
  
} //IntField
//----------------------------------------------------------------
class StringField extends TField
{
  public $type='string';
  //  ,   
  public $size;
  //     POST-  
  public $codepage='windows-1251//IGNORE';  

  
  function make_edit_attr(&$at)
  { $at['type']='text';
	if($this->size) $at['maxlength']=$this->size;  
  }

  
  function parse($v)
  { if($v!='') 
      if($this->codepage) return iconv('utf-8', $this->codepage, $v);
                    else  return $v;
    else return null;
  }  
  
  function validate($v)
  { parent::validate($v);
    if(!is_null($v) && $this->size && strlen($v)>$this->size)
     throw new Exception(" '$this->caption'   ");
  }    
} //StringField
//----------------------------------------------------------------

class BoolField extends IntField
{
  public $type='bool';
  
  public $default=0; // $default     'new'
  
  public $checked=1,
         $unchecked=0;
  
  function get_default($action)
  { if($action=='new') 
          return $this->default ?? $this->unchecked;
	 else return $this->unchecked;	 
  }
		 
  function get_classes($value, $row)  { return ['boolField']; }
  
  function draw_text($val, $row)
  { echo "<input type=checkbox", $val==$this->checked ? ' checked' : '', '>'; }
  
  function draw_editor($value, $row, $action)  
  { if($this->readonly ?? false) $this->draw($value, $row);
    else
	{
      echo '<td class="inplace boolField">';
	  $at['name']= $this->get_name($action);
	  $at['type']='checkbox'; 
	  if($value==$this->checked) $at['checked']=null;
      echo '<input'; draw_html_attr($at); echo '>';	  
	  echo '</td>';
    }		 
  }
  
  function parse($v)  
  { if($v=='on')  //      
         return $this->checked;
    else return parent::parse($v); 
  } 
  
} //BoolField

//----------------------------------------------------------------
class DateField extends TField
{
   public $type='date';
   // ;     DateTime,   DateTime
   public $min;
   // ; 
   public $max;
   //        
   public $format='d.m.Y';

   function draw_text($v, $row) 
   { if(!is_null($v))
	  { $dt = new DateTime($v);
        echo $dt->format($this->format);
	  }  
   }
	 
   function draw_edit_text($v, $row)   
   { 
      if(!is_null($v))
	  { $dt = new DateTime($v);
        echo $dt->format('Y-m-d');
	  }  	 
   }
	 
  
  function make_edit_attr(&$at)
  { $at['type']='date';
     if($this->min)
	 {  if(is_string($this->min)) $this->min=new DateTime($this->min);
        $at['min']=$this->min->format('Y-m-d');
     }		
     if($this->max)
	 {  if(is_string($this->max)) $this->max=new DateTime($this->max);
        $at['max']=$this->max->format('Y-m-d');
     }		
  }
   	
} //DateField
//----------------------------------------------------------------
class DateTimeField extends TField
{
   public $type='datetime';
   //   
   public $format='d.m.Y H:i:s'; 
   public $format_zero; //    0
   public $step; //  ,     

   function draw_text($v, $row) 
   { if(!is_null($v))
	  { $dt = new DateTimeImmutable($v);
	    if($this->format_zero && $dt==$dt->setTime(0,0))
		     echo $dt->format($this->format_zero);
	    else echo $dt->format($this->format);
	  }  
   }
  
	 
   function draw_edit_text($v, $row)   
   { 
     if(!is_null($v)) echo (new DateTime($v))->format('Y-m-d\TH:i:s');
   }
   
  function parse($v)
  {  if($v=='') return null;
           else return (new DateTime($v))->format('Y-m-d H:i:s'); //d.m.Y G:i:s
  }	     	 
  
  function make_edit_attr(&$at)
  { $at['type']='datetime-local'; 
    if($this->step) $at['step']=$this->step;
  }
   	
} //DateField



//----------------------------------------------------------------
class LookupField extends TField
{ //   => 
  public $list=[]; 
  
  
  //   .   [ , $list].  ===null     
  // ,   $list.  
  public $optgroups=[];

  function draw_text($value, $row)    
  { 
    if(!$this->optgroups) echo htmlspecialchars($this->list[$value] ?? '');  
	else
     foreach($this->optgroups as $og)
	   if(isset($og[1][$value]))
	   {  echo htmlspecialchars($og[1][$value]);  
	      return;
	   }
  }  
  
  
  function draw_list($value, $list)
  {
    foreach($list as $k=>$name)
 	  echo "<option value='$k'", $value==$k ? ' selected' : '',">",htmlspecialchars($name),"</option>\r\n";
  }
  
  //  
  function draw_items($value, $row)
  {
    if($this->optgroups)
	  foreach($this->optgroups as $og)
	  { if(!is_null($og[0])) echo '<optgroup label="',htmlspecialchars($og[0]),'">',"\r\n";
        $this->draw_list($value, $og[1]); 
	    if(!is_null($og[0])) echo "</optgroup>\r\n";
	  }   
    else $this->draw_list($value, $this->list);   
  }
  
  
  function draw_editor($value, $row, $action)  
  { if($this->readonly ?? false) $this->draw($value, $row);
    else
	{
      echo '<td class=inplace>';
	  echo '<select';
	  $at=[ 'name'=> $this->get_name($action)];
	  if($this->required)  $at['required'] =null; 
	  $this->make_edit_attr($at);
	  draw_html_attr($at);
      echo ">\r\n";
	  if($action=='insert' && is_null($value))
	    echo "<option value=''></option>";
	  $this->draw_items($value, $row);	  
	  echo "</select></td>\r\n";
    }		 
  }  

} //LookupField
//----------------------------------------------------------------
class DBLookupField extends LookupField
{ public $query; //       
  private $loaded=false;

  function load_list()
  {
    foreach($this->dataset->db->query($this->query) as [$key,$value])
      $this->list[$key]=$value;  
    $this->loaded=true;
  }

  function draw_text($value, $row)    
  { if(!$this->loaded) $this->load_list();
    parent::draw_text($value, $row);
  }
  
  function draw_items($value, $row)
  { if(!$this->loaded) $this->load_list();
    parent::draw_items($value, $row);
  }

} //DBLookupField
//---------------------------------------------------------------- 
 //int      
class GenIntField extends IntField
{
  //              
  public $generator;

  function gen_id() { return $this->dataset->db->gen_id($this->generator); }
  
  function get_default($action)
  { 
    if($action=='insert') return $this->gen_id();	  
  }    
}
//----------------------------------------------------------------  

 //   
function draw_html_attr($a)
{
   if($a) 
    foreach($a as $n=>$v)
     {echo ' ',$n;
      if(!is_null($v)) 
	       echo '="',htmlspecialchars($v),'"';
     } 
} 
//   //  $inner,    
function draw_html_tag($tag, $at, $inner=null)
{ echo '<', $tag;
  draw_html_attr($at);
  echo '>';
  if(!is_null($inner))
   echo htmlspecialchars($inner), "</$tag>";
}
//----------------------------------------------------------------  
 
