<?php
include "datafield.php";

class TDataset
{
//-  class field
 public $fields=[];
 //  => ( )
 public $fn=[];
//    
 public $db;
 //     
 public $action;
 public $params=[]; //     
 
 // run()    GET  ( POST - ).
 protected $autorun=true;

//  make_sort -   select_sql     sort=fld&desc
 protected $autosort=false; 
// autosort=true      ,       
 protected $defsort;
 
//   select        
//      refresh 
 protected $autoselect=false; 
 
 //    update  insert,  -     refresh
 protected $full_refresh=false; 
 
 //    
 protected $reverse=false; 
 
  //   
 protected $error_map=[];
 
 protected $select_sql;
 protected $update_sql;
 protected $insert_sql;
 protected $refresh_sql;
 protected $delete_sql;
 
 
 //    
 function get_tr_classes($row)  { return []; }

//     , ..     selected
 function check_selected($row)
 { $res=false;
   foreach($this->fields as $f)
    if($f->key)
      if($row[$f->name]==($this->params[$f->names['*']] ?? null)) 
	       $res=true;
	  else return false;       
   return $res;
 }
 
 //    .    tr data-*
 //      
 function get_row_data($row)
 { $d=[];
   foreach($this->fields as $f)
    if($f->data)
	 $d[$f->names['*']] = isset($row[$f->name]) ? $f->get_data_text($row[$f->name]) : null;
   return $d;
 }
 
 // data-*
 function echo_data($row)
 { foreach($this->get_row_data($row) as $name=>$value)
    if(!is_null($value))
     echo " data-$name='$value'";
 }

 //   ,  
 function fetched(&$row){}
 
 //    . 
 function draw_row($row)
 { 
   $this->fetched($row);
   echo '<tr';  
   $cl=$this->get_tr_classes($row);
   
   if($this->autoselect && $this->check_selected($row))
   {  $cl[]='selected';     
      $this->autoselect=false;
   }	   
   
   if($cl)
     echo ' class="'.implode(' ', $cl).'"';      
   $this->echo_data($row);  
   echo '>';
   foreach($this->fields as $f)
     if($f->visible)
       $f->draw($row[$f->name] ?? null, $row);
   echo "</tr>\r\n";
 }

 
 //  
 function draw_colgroup()
 {
   echo "<colgroup>\r\n";
   foreach($this->fields as $f)
    if($f->visible)
	  $f->draw_col();
   echo "</colgroup>\r\n";
 }

 
 // 
 function draw_thead()
 { 
   echo "<thead>";
   $extra_bottom = [];
   
   foreach($this->fields as $f)
     if(isset($f->extra_caption))  
	   foreach(array_slice($this->fields, $f->index, $f->extra_colspan ?? 1) as $ef)
         $extra_bottom[]=$ef;
 
   echo "<tr>\r\n"; //first line
   foreach($this->fields as $f)
    if($f->visible) 
	  { if(isset($f->extra_caption)) 
	         $f->draw_extra_head();
	    else
		if(!in_array($f, $extra_bottom))
		{ if($extra_bottom) $f->th_attr['rowspan'] = 2;
	      $f->draw_head();
		}	  
	  }
   echo "</tr>\r\n";

   if($extra_bottom) //second line
   { 
	 echo "<tr>\r\n";
	 foreach($extra_bottom as $f)
  	   $f->draw_head();
	 echo "</tr>\r\n"; 
   } 	
   
   echo "</thead>\r\n";
 }

 //    
 function draw($q)
 { 
   $this->draw_colgroup();
   $this->draw_thead();
   echo "<tbody>\r\n";
   $this->draw_body($q);
   echo "</tbody>\r\n";
 }
 
 function draw_body($q)
 {
    if(!is_array($q) && $this->reverse)
     $q=array_reverse($q->fetchAll(PDO::FETCH_ASSOC)); 
   
   if(is_array($q))
     foreach($q as $r)
       $this->draw_row($r);   
   else
   while($r=$q->fetch(PDO::FETCH_ASSOC)) 
     $this->draw_row($r);
 }
 
 //  
 function on_select($params)
 { if($this->autosort)   $this->make_sort($params);
   if(!$this->select_sql) throw new Exception(' select_sql');
   $q=$this->prepare_execute($this->select_sql, $params);
   $this->draw($q);
 } 
 
 //    tbody,    scroll_sql   select_sql
 function on_scroll($params)
 { $this->draw_body($this->prepare_execute(isset($this->scroll_sql) ? $this->scroll_sql : $this->select_sql, $params)); } 
 
 
 // 
 function on_refresh($params)
 { if(!$this->refresh_sql) throw new Exception(' refresh_sql');
   $q=$this->prepare_execute($this->refresh_sql, $params);
   $this->autoselect=false;
   if($r=$q->fetch(PDO::FETCH_ASSOC))
      $this->draw_row($r);
  } 
 
 //      ,        on_refresh
 function reload($params, $action)
 { 
  foreach($this->fields as $f)
   if(isset($f->names[$action]))
    $params[$f->names['*']]=$params[$f->names[$action]] ?? null;

  if($this->full_refresh)
        $this->on_select($params);
   else $this->on_refresh($params);	
 }
 
 //
 function on_delete($params)
 { if(!$this->delete_sql) throw new Exception(' delete_sql');
   $this->prepare_execute($this->delete_sql, $params); }
 
 //       
 function prepare_input_params(&$params, $action='*')
 {
   $this->set_defaults($params, $action);
   $this->validate($params, $action);
 } 
 
 // 
 function on_update($params)
 { if(!$this->update_sql) throw new Exception(' update_sql');
   $this->prepare_input_params($params, 'update');
   $this->prepare_execute($this->update_sql, $params);
   $this->update_also($params);
   $this->reload($params, 'update');
 }

 //    update_sql
 function update_also($params){}
 
  //
 function on_insert($params)
 { if(!$this->insert_sql) throw new Exception(' insert_sql');
   $this->prepare_input_params($params, 'insert');
   $this->prepare_execute($this->insert_sql, $params);
   $this->insert_also($params);
   $this->reload($params, 'insert');
 }
 
 //    insert_sql
 function insert_also($params){}
 
 // 
 function on_edit($params)
 { if(!$this->refresh_sql) throw new Exception(' refresh_sql');
   $q=$this->prepare_execute($this->refresh_sql, $params);
   $row=$q->fetch(PDO::FETCH_ASSOC);
   if(!$row) throw new Exception("  ");	     
   $this->fetched($row);

   $this->draw_editor($row, 'update');
 }		 
 
 // 
 function on_new($params)
 {
   $this->draw_editor($this->default_row($params), 'insert');
 } 
 
 function draw_editor($row, $action)
 {
   echo '<tr'; $this->echo_data($row);  echo '>';   
   foreach($this->fields as $f)
     if($f->visible)
       $f->draw_editor($row[$f->names['*']] ?? null, $row, $action); 
   echo "</tr>";   
 }
 
 
 //        
 //     
 function set_defaults(&$params, $action='insert')
 { 
  foreach($this->fields as $fld)
   if(!isset($params[$fld->get_name($action)]))
    if(!is_null($def=$fld->get_default($action)))
     $params[$fld->get_name($action)] = $def; 
 }

 //         new.
 function default_row($params)
 { $r=[];
   $this->set_defaults($r, 'new');
   return $r;
 } 
 
 
 //    ,   ,  null
 function param2field($name)
 { foreach($this->fields as $f)
    if(in_array($name, $f->names))
	  return $f;
   return null;	 //throw new Exception(" : $name");
 }
 
 //   
 function name2field($name)
 { foreach($this->fields as $f)
    if($f->name==$name)
	  return $f;
   throw new Exception(" : $name");
 }

 
 //  (    )
 function validate($params, $action)
 { //     
   foreach($this->fields as $f)
     if(!($f->readonly ?? !$f->visible))
      $f->validate_params($params, $action);
  
   $this->validate_also($params, $action);	  
 }
 
 function validate_also($params, $action)
 {}
 
 //  
 function set_visible($names, $val=true) 
 {
   foreach($this->fields as $f)
     $f->visible = in_array($f->name, $names)==$val;   
 }
 
 //    
 function set_notreadonly($names, $val=false) 
 {
   foreach($this->fields as $f)
     $f->readonly = in_array($f->name, $names)==$val;   
 }
 
 
 function make_sort($params)
 {
   if($sortname=$params['SORT'] ?? $this->defsort)
        $f=$this->fn[$sortname];
   else foreach($this->fields as $f)	 
      	  if($f->visible) break;
		  
   $dir = isset($params['DESC']) ? 'desc' : 'asc';   
   $this->select_sql.=' order by '.$f->get_sort_expr($dir);
   if(isset($params['SORT']))
  	 $f->th_class[]='sort'; 
   $f->th_class[]=$dir;	 
 }

 // $s -  ,       
 function prepare_execute($s, $params)  
 { 
   if(is_array($s))
         foreach($s as $sql) $this->db->prepare_execute($sql, $params); 
    else return $this->db->prepare_execute($s, $params); 
 
 }
 
 //    
 //  before_*,  on_* ( ),  after_*
 function exec_action($action, $params)
 {  
   $on_action='on_'.$action;
   if(method_exists($this, $on_action))
   {   $before_action='before_'.$action;
       if(method_exists($this, $before_action)) $this->$before_action($params);   
       $this->$on_action($params);
	   $after_action='after_'.$action;
       if(method_exists($this, $after_action)) $this->$after_action($params);   	   
   }
   else throw new Exception("Unknown action: $action");	     
 }
 
// function params_add(&$params, $row, $keys) {  $params+=array_intersect_key($row, array_flip($keys)); }

//    
function init_files()			
{ 
 //fail(var_export($_FILES, true));
 foreach($_FILES as $name=>$info)  
  if($info['name'])
     if($info['tmp_name'])  $this->params[$name] = file_get_contents($info['tmp_name']);
                      else  throw new Exception("   $info[name]");		 
  else $this->params[$name] = null;
}
 

//  ,         
function normalize(&$params)
{ foreach($params as $name=>$v)
    if($f=$this->param2field($name))
	 if(is_array($v))
	      $params[$name]=$f->parse_array($v);		    
     else $params[$name]=$f->parse($v);		    
}

//   ( )
function restrict($params, $action)
{
  foreach($params as $name=>$v)
    if($f=$this->param2field($name))
	 if(is_array($v))
	      foreach($v as $va)
		    $f->restrict($va, $action);		    
     else $f->restrict($v, $action);		    
}

//  : , ,  (    )
// GET  select
// POST   action  query string; 
 function set_run_context()
 {      
   $this->db=$GLOBALS['db'];
 
   if($_SERVER['REQUEST_METHOD']==='POST')
   { $this->action=$_GET['action'];
     $this->params=$_POST;
	 $this->init_files();
	 $this->autorun=true;
	 $this->db->autocommit=false;
   }
   else
   { $this->action='select';
     $this->params=$_GET;  
   }

   $this->params=array_change_key_case($this->params,CASE_UPPER);         
   
   foreach($this->params as $name=>$value)
     if(str_starts_with($name, '@')) throw new Exception("Invalid param: $name");   
 }
 
 function run() 
 { 
   try 
    { $this->exec_action($this->action, $this->params); 
      if($this->db->autocommit==false) 
	     $this->db->commit();    
	}
   catch(PDOException $e) 
    { $this->handle_error($this->action, $e); }
   
 }
 
 //               ( ) 
 function init(){} 
 
 function init_fields() //    :   ,  
 { foreach($this->fields as $idx=>$f)
   { $f->dataset = $this;
     $f->index = $idx;
	 $f->names['*']=strtoupper($f->name);
	 $this->fn[$f->name]=$f;
   }
 }
 
 function __construct()
 {
   $this->set_run_context(); //  
   $this->init();            // 
   $this->init_fields();     //.   
   $this->normalize($this->params); //      
   $this->restrict($this->params, $this->action); //
   if($this->autorun) 
      $this->run(); 
 }
 
 
 //       PDOException
 function handle_error($action, $e)
 { 
   foreach($this->error_map as $key=>$s)
    if(str_contains($e->getMessage(),$key))
	  throw new Exception($s);	         
   throw $e;
 } 
 
} //TDataset
//---------------------------------------------------------------- 
