<?php 
const dev_addr_step=100;

function is_dev_ip_addr($addr) {return $addr!=-1 && ($addr & (0xff0000 << 8));}

function dev_addr_to_vetv($addr) {return intdiv($addr,dev_addr_step);}

function dev_addr_str($v)
{ if(is_dev_ip_addr($v))
       return long2ip($v);
  else return strval($v);
}

function str_to_dev_addr($s)
{
 if(str_contains($s,'.'))
 { $v = ip2long($s);
   if(($v & (int)0x80000000) && $v>0)
     $v= (~$v) ^ 0xffffffff;
   return $v;  
 } 
 else return intval($s);
}

function valid_dev_addr($s)
{
 return  filter_var($s, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)!==false 
         || 
		 filter_var($s,  FILTER_VALIDATE_INT, [ 'options' => ['min_range'=>0, 'max_range'=>1000]])!==false;
}
