<?php
include_once("system.php"); 
include_once("colors.php");
/*
 ?mode=[new|last|prev|next]&num=[]&count=[]&datetime=[]
 
 new  -   num (   )
 last -  count 
 first -  count 
 prev -     num|datetime  count
 next -     num|datetime  count 
 from -     num|datetime  count,     marked 
 
*/

if($_SERVER['REQUEST_METHOD']==='POST') //autorun in POST
  events_load($_POST['mode'], $_POST);
 
  
function events_load($mode, $load_params)  
{
global $db;

$count = intval($load_params['count'] ?? 0);
if($count<=0 || $count>10000) $count=10000; //limit max count for safety

$fields =['events.num', 
          'events.datetime',
		  '(select msg from D_EVENT_MSG(events.event_type,events.param1,events.param2,events.param3,events.param4,events.param5)) as msg',
		  '(select color from d_events_type where id=events.event_type) as color'
		 ];

$params =  ['count' => $count]; // 

$where = ['system_type=2']; //

$tables = ['EVENTS']; // 


if(!empty($load_params['user'])) //  
{ $join_types=true;
  $where[]='param2=:user';
  $where[]='E_USER=1';
  $params['user']=$load_params['user'];
}

if(!empty($load_params['group'])) //  
{ 
  $join_users=true;
  $where[]='USERS.USERGROUP=:group';
  $params['group']=$load_params['group'];
}

if(!empty($load_params['computer']))
{ $join_types=true;
  $where[]='PARAM1=:computer';
  $where[]='E_COMPUTER=1';
  $params['computer']=$load_params['computer'];
  
}

if($class=$load_params['class'] ?? '')
{ $join_types=true;
  if(str_starts_with($class,'wf'))
         $where[]='workflow='.substr($class, 2);
    else $where[]='e_'.$class.'=1';
}  

if(!empty($load_params['type']))
{
  $vals=[];  
  foreach(explode(',', $load_params['type']) as $t)
    $vals[]=intval($t);   
  $where[]='EVENT_TYPE in ('.implode(',',$vals).')';
}

if(!empty($load_params['reader'])) //    : 1,2,3,4
{ $join_types=true;
  $vals=[];  
  foreach(explode(',', $load_params['reader']) as $r)
    $vals[]=intval($r);   
  $where[]='PARAM1 in ('.implode(',',$vals).')';
  $where[]='E_HARDWARE=1';
}

if(!empty($load_params['tz'])) //  
{ 
  $join_types=true; $join_tz_links=true;
  $where[]="D_TER_ZONES_LINK.TER_ZONE+0=:tz"; 
  $params['tz']=$load_params['tz'];    
}

if(!empty($load_params['editor'])) //  
{ $join_types=true;
  $where[]="PARAM1=:editor";
  $params['editor']=$load_params['editor'];      
}


if(isset($load_params['start']))
{ $load_params['start_date'] = (new DateTime("-$load_params[start] day"))->format('Y-m-d');
  if(!empty($load_params['end_time']) && !isset($load_params['through']))  
     $load_params['end_date']=$load_params['start_date'];
}

if(!empty($load_params['start_date'])) // 
{
 $where[]='DATETIME>=:start';
 $params['start']=$load_params['start_date']; 
 if(!empty($load_params['start_time'])  && !isset($load_params['through'])) 
    $params['start'].=' '.$load_params['start_time'];
}

if(!empty($load_params['end_date'])) // 
{
 $where[]='DATETIME<:end';
 $params['end']=$load_params['end_date']; 
 if(!empty($load_params['end_time']) && !isset($load_params['through']))  
    $params['end'].=' '.$load_params['end_time'];
}

if(isset($load_params['through'])) // 
{
 $t1 = strtotime($load_params['start_time'].'UTC', 0);
 $t2 = strtotime($load_params['end_time'].'UTC', 0);
 $where[]="extract(HOUR from datetime)*60*60+extract(MINUTE from datetime)*60+extract(SECOND from datetime) ".($t2<$t1 ? "not between $t2 and $t1" : "between $t1 and $t2");
}
 

foreach($load_params as $key=>$value) //    . 
 if(str_starts_with($key, 'show_'))
 { $join_types=true;
   $fn= explode('_', $key)[1];
   if($fn=='tab') $fields[]='(select TABEL_NUMBER from users where num=events.param2 and d_events_type.e_user=1) as TABEL_NUMBER';   else
   if($fn=='group') $fields[]='(select groupname from users,groups where groups.num=users.usergroup and users.num=events.param2 and d_events_type.e_user=1) as groupname';   else
   if(is_numeric($fn)) $fields[] = "(select prop_value from user_props where prop_id=$fn and user_num=events.param2 and d_events_type.e_user=1) as PROP$fn";    
 }



if($join_users ?? false)
{ $join_types=true;
  $tables[]='USERS';
  $where[]='E_USER=1';
  $where[]='PARAM2=USERS.NUM'; 
} 
 
if($join_types ?? false)
{
  $tables[]='D_EVENTS_TYPE'; 
  $where[]='EVENT_TYPE=D_EVENTS_TYPE.ID';
  $fields[3] ='D_EVENTS_TYPE.color';  
}

if($join_tz_links ?? false) 
{ $tables[]="D_TER_ZONES_LINK"; 
  $where[]="E_HARDWARE=1 AND PARAM1=D_TER_ZONES_LINK.READER";
}


 
switch($mode)
{ case 'new':   $where[]="events.num>:num"; 
                $params['num'] = $load_params['num'];
				break;
  case 'prev':  
  case 'next':  
  case 'from':    $operator_map = [ 'prev' => '<', 'next' => '>', 'from' => '>='];
                  if(isset($load_params['datetime']))
                       { $where[]='datetime'.$operator_map[$mode].':datetime'; 
   					     $params['datetime'] = $load_params['datetime'];
					   }
                  else { $where[]='datetime'.$operator_map[$mode].'(select datetime from events where num=:num)';  
           				 $params['num'] = $load_params['num'];
				       }
				break;
} 

$order=''; //make query datetime order
switch($mode)
{ case 'last':   case 'prev':                $order='desc'; break;
  case 'first':  case 'next':  case 'from':  $order='asc';  break;
} 


$query = 'select first :count '.implode(',',$fields).' from '.implode(',',$tables).' where '.implode(' and ',$where); 
if($order) $query.=" order by datetime $order";
//echo $query;
$q=$db->prepare($query);
$q->execute($params);

$rows=$q->fetchAll(PDO::FETCH_NUM); 

if($order=='desc') $rows=array_reverse($rows);

if($mode!='new' && count($rows)<$count)
 $eof_idx = $order=='desc' ? 0 : count($rows)-1; //eof flag position 

foreach($rows as $idx=>$r) 
{
 $class = '';
 if($idx==0 && $mode=='from') $class=' class=marked';
 
 $eof='';
 if(isset($eof_idx) && $idx==$eof_idx) $eof=' data-eof=true';
  
 $color = $r[3] ? ' style="color: black; background-color: '.html_color($r[3]).'"' : '';

 $dt = new DateTime($r[1]); 				 
 echo "<tr$class data-num=$r[0] data-datetime='$r[1]'$eof>",
      "<td>", $dt->format('G:i:s'), "</td>", 
      "<td>", $dt->format('d.m.y'), "</td>",
	  "<td$color>$r[2]</td>"; 

 for($i=4; $i<count($r); $i++)	echo "<td>$r[$i]</td>"; //.      
	  
 echo "</tr>\r\n";
}

} //events_load
?>