<?php 
include "system.php"; 
include "login.php"; 
include "options.php"; 
assert_right(RT_FUNCTIONS, RI_EVENTSBASE);

$sid_filter=new d_sid_option('filter');

if($_SERVER['REQUEST_METHOD']==='POST') 
{
$params=[];
foreach($_POST as $name=>$value)
if(!str_starts_with($name, 'filter_'))
 if(is_array($value) || $value!='')
  switch($name)
  { case 'type':     $params[]='type='.implode(',', array_keys($value));
	         		 break; 
					
    case 'group':    if(!empty($_POST['user'])) break;					
                    
    default:  if($value=='on')
                   $params[]=$name;
              else $params[]="$name=$value";
  }

$data=implode('&', $params); 
  
if(isset($_POST['filter_new']))  //create filter
{
  $q=$db->prepare('insert into D_FILTERS (editor,name,data) values (:editor,:name,:data)');
  $q->execute([$editor, $_POST['filter_name'], $data]);
}
else  
if(isset($_POST['filter_save'])) //save filter
{
   $q=$db->prepare('update D_FILTERS set name=:name, data=:data where editor=:editor and id=:id');
   $q->execute([$_POST['filter_name'], $data, $editor, $_POST['filter_id']]);
}
else
if(isset($_POST['filter_delete'])) //delete filter
{    
  $q=$db->prepare('delete from D_FILTERS where id=:id and editor=:editor');
  $q->execute([$_POST['filter_id'], $editor]);  
}
else
if(isset($_POST['filter_apply'])) //apply filter
{  
 if($nwk=array_keys($params, 'newwin'))
   $params[$nwk[0]]='nomenu';
 header("Location: events.php?".implode('&', $params));
}

if(isset($_POST['filter_delete']))
     $sid_filter->clear();
else $sid_filter->set($data); 

if(!isset($_POST['filter_apply']))
  header("Location: filter.php");



exit();
} //if POST

//GET
include "form.php"; 
include "colors.php"; 
?>

<link rel="icon" href="img/14.png">
<link rel="stylesheet" href="TButton.css">

<style>
#filter { background: var(--tables-background);
		  display: inline-block;
          border: 1px solid black;
          padding: 2px 5px;
		  padding-top: 5px;		  
        } 

#layout { writing-mode: vertical-lr; }
#layout>fieldset { display: inline-block;
                   width: 63ch;
                   writing-mode: horizontal-tb;
				   vertical-align: middle;
				 }
		
/*		
#layout { column-gap: 5px;
		  column-count: 2;  }		
		
#layout>* {break-inside: avoid;
           margin: 0;       }		
*/	  
		
#filter legend {border: 1px solid gray;
                background: #DDD; }

#filter fieldset>legend {border-radius: 3px;}
		
				
#btns button { height: 2.3em;
               width: 11ch;
               margin-right: 5px; 
               outline: none;
			   }				


fieldset { padding: 5px; 
           min-width: 0;     
    	 }		  
			
#photo {max-width: 100%;
        max-height: 100%;
		left: 50%;
		top: 50%;		
		transform: translate(-50%,-50%);
		position:absolute;
       }

#photobox { width: 100%;
			padding: 0;
			position:relative;
			border-radius: 10px;
		  }
			 
				
#username {min-width: 28ch;}				


				
</style>


<title> </title>
</head>
<body id=workarea>

<script>
function form_reset()
{ userlist.classList.add('empty');
  filter.reset();
  filter.user.value='';
  photo.src='';
  filter_id.dataset.id='';
  on_start_name_change();  
  on_class_change();
}

function form_submit(ev)
{ 
  if(filter.newwin.checked) filter.setAttribute('target','_blank');

  if(!username.value) return;
  for(let op of userlist.options)
   if(op.value==username.value)
   { filter.user.value=op.dataset.num;
     return;
   }
   
  alert('  ');   
  ev.preventDefault();
}
</script>

<!--========================================================================-->

<form id=filter class="fix-height" method=POST autocomplete=off onsubmit="form_submit(event)">
<div id=layout>
<fieldset>
<legend>  </legend>
<table>
<tr><td></td>
<td><select name=group onchange='load_userlist()'>
<option value=''></option>
<?php
foreach($db->query('select NUM,GROUPNAME from GROUPS '.sql_where("where num",RT_GROUPS).' order by GROUPNAME') as $row)
 echo "<option value='$row[0]'>$row[1]</option>";
?>
</select>
</td>
<td rowspan=6 id=photobox>
<img id=photo src="" alt="">
</td>
</tr>

<tr><td></td>
<td>
<select id=usertype onchange="load_userlist()">
<option value=owner></option>
<option value=deleted></option>
<option value=guest></option>
<option value=history></option>
</select>
</td></tr>

<tr><td></td>
<td style="white-space: nowrap">
<input type=hidden name=user> 
<input type=text id=username list=userlist placeholder=' ' spellcheck=false onfocus="on_username_focus()" onchange="on_username_change()"
><button type=button onclick="username.value=''; on_username_change();" title='  ' style="padding: 1px 3px">x</button> <!-- <img src="img/winclose.png"> -->
<style>
#username:placeholder-shown+button {display: none;}
</style>

<script>
function on_username_focus()
{ if(userlist.classList.contains('empty')) load_userlist();
}

function on_username_change()
{
 photo.src='';
 photobox.style.backgroundColor='';
 if(username.value)
  for(let op of userlist.options)
   if(op.value==username.value)
   { photo.src="photo.php?num="+op.dataset.num;
     if(op.dataset.color)
       photobox.style.backgroundColor=op.dataset.color;
     return;
   }
}


function load_userlist()
{ username.value='';
  on_username_change();
  var fd=new FormData;
  fd.set('group', filter.group.value);
  var xhr = new XMLHttpRequest;
  xhr.open('POST', 'filt_users.php?type='+usertype.value, false);
  xhr.send(fd);
  if(xhr.status==200)  
    {  userlist.innerHTML = xhr.responseText;   
   	   userlist.classList.remove('empty');
	}
  else alert(xhr.responseText); 
}
</script>

<datalist id=userlist class=empty>
<option value=''>
</datalist>
</td></tr>


<tr><td></td>
<td><select name=editor>
<option value=''></option>
<?php
foreach($db->query('select EDITOR,  EDITOR_NAME from D_EDITOR_SETTINGS '.sql_where("where EDITOR",RT_OPERATORS).' order by EDITOR_NUM') as $row)
 echo "<option value='$row[0]'>$row[1]</option>";
?>
</select>
</td></tr>

<tr><td></td>
<td><select name=tz>
<option value=''></option>
<?php
foreach($db->query('select NUM,ZONENAME from TER_ZONES '.sql_where("where NUM",RT_TZ).' order by ZONENAME') as $row)
 echo "<option value='$row[0]'>$row[1]</option>";
?>
</select>
</td></tr>

<tr><td></td>
<td><select name=reader>
<option value=''></option>
<?php
foreach($db->query('select READER,READ_NAME from D_ABSTRACT_READERS '.sql_where("where READER",RT_READERS).' order by READ_NAME') as $row)
 echo "<option value='$row[0]'>$row[1]</option>";
?>
</select>
</td></tr>
</table>
</fieldset>

<!--========================================================================-->
<fieldset id=times>
<legend>  </legend>
<style>
#start_date:disabled, 
#times.dates #start_name   { display: none; }  

#times:not(.dates) #td_end>*,
#times:not(.dates) #td_end+td>* {visibility: hidden;}

#times td:nth-child(3) { padding-left: 3ch;} 
</style>

<script>
function on_start_name_change()
{ start_date.disabled = start_name.value!='';
  times.classList.toggle('dates', !start_date.disabled);
}
</script>

<table>
<tr>
<td> </td>
<td>
<input type=date id=start_date name=start_date required disabled>

<select id=start_name name=start onchange="on_start_name_change()">
<option value='0'></option>
<option value='1'></option>
<option value='2'></option>
<option value='7'> </option>
<option value='30'> </option>
<option value=''> ...</option>
</select>


</td>
<td> </td>
<td><input type=time name=start_time></td>
</tr>

<tr>
<td id=td_end><span> </span></td>
<td><input type=date name=end_date></td>
<td> </td>
<td><input type=time name=end_time></td>
</tr>
</table>
</fieldset>

<!--========================================================================-->
<fieldset>
<legend> </legend>
<label><input type=checkbox name=through>  ""   </label><br> 
<label><input type=checkbox name=live>  </label><br> 
<label><input type=checkbox name=newwin>   </label><br> 
<label><input type=checkbox name=all>   </label>
</fieldset>

<!--========================================================================-->
<br>

<fieldset>
<legend> </legend>
<button name=filter_new onclick="on_filter_new(event)" title="      "></button>
<span class=filter></span> <select class=filter id=filter_id name=filter_id onchange="on_filter_change();">
<option value='' data-data=''></option>
<?php
$filter_count=0;
foreach($db->query("select id,name,data from D_FILTERS where editor=$editor order by name") as [$id, $name, $data])
 if(ctype_print($data)) //skip desktop maid filters 
 {  echo "<option data-data='$data' value=$id>$name</option>";
    $filter_count++;
 }
?>
</select>
<button name=filter_save   onclick="on_filter_save(event)"  ></button>
<button name=filter_delete onclick="on_filter_delete(event)"></button>
<input type=hidden name=filter_name>
<script>
function on_filter_new(ev)
{ 
 if(name=prompt('   '))
       filter.filter_name.value=name;
 else  ev.preventDefault();  
}

function on_filter_change()
{ var id=filter_id.value;
  var data=filter_id.options[filter_id.selectedIndex].dataset.data;
  form_reset();
  filter_id.value=id;
  filter_id.dataset.id=id;
  select_filter(data);
}


function on_filter_save(ev)
{ 
 if(name=prompt('   ', filter_id.options[filter_id.selectedIndex].text))
       filter.filter_name.value=name;
 else  ev.preventDefault();  
}

function on_filter_delete(ev)
{ if(!confirm('  ?')) ev.preventDefault(); }
</script>

<style>
#filter_id[data-id='']~button,
#filter_id:not([data-id])~button  {display: none}

#filter_id {min-width: 10ch;}

<? if(!$filter_count) echo ".filter { display: none }"; ?>
</style>

</fieldset>
<!--========================================================================-->

<fieldset>
<legend> </legend>
<div style="column-count: 2">
<?php
$props= [ ['tab',' '],
          ['group', ''] ];
$props=array_merge($props, $db->query("select ID,PROP_NAME from USER_PROP_TYPES order by id")->fetchAll(PDO::FETCH_NUM));

foreach($props as [$id, $name])
  echo "<label><input type=checkbox name=show_$id>$name</label><br>";
?>
</div>
</fieldset>
<!--========================================================================-->
<fieldset>
<legend> </legend>
 
<select name=class onchange="on_class_change()">
<option value=''></option>
<option value='' id=custom_types> ...</option>
<optgroup label="&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;">
<option value=warn></option>
<option value=operator></option>
<option value=dostup></option>
<option value=spmaster></option>
<option value=door></option>
<option value=generalsystem></option>
<option value=computer></option>
</optgroup>
<optgroup label="">
<?php
foreach($db->query('select workflow, name from DW_WORKFLOWS where actived=1 and workflow>=2 order by workflow') as [$wf, $name])
 echo "<option value=wf$wf>$name</option>\r\n"
?>
</optgroup>
</select>

<script>
function on_class_change()
{types.disabled=!custom_types.selected; }
</script>
</fieldset>
<!--========================================================================-->
<fieldset id=types disabled>
<!-- <legend> </legend> -->
<?php 
foreach($db->query('select t.id, t.msg, t.color from D_EVENTS_TYPE t 
                    left join DW_WORKFLOWS w on t.workflow=w.workflow
					where t.workflow is null or w.actived=1  
					order by t.id') as [$id, $msg, $color])
 echo "<label style='background: ", is_null($color) ? 'white' : html_color($color),"'>",
      "<input type=checkbox name=type[$id]><span class=etnum>$id</span>$msg</label>\r\n";
?>
<style>
#types label {display: block;
              white-space: nowrap;
			  overflow: hidden;
             }		
#types label>* {vertical-align: middle;}

#types { padding: 0;  }

#types     { height: 13em;
             overflow-y: auto;
			 resize: vertical;
			 border-top: none;
           }

#types .etnum { display: inline-block;        
                width: 4ch;
                margin: 0 1ch;}
				
#types:disabled {visibility: hidden;}				
</style>
</fieldset>
<!--========================================================================-->
</div> <!-- layout -->



<div id=btns>
<button type=submit class=TButton name=filter_apply><img src="img/ok.png"><span></span></button>
<button type=button class=TButton onclick="form_reset()"><span></span></button>
</div>
</form>



<script>
var init_filter='<? echo $sid_filter->get('') ?>';

function select_filter(data)
{
  var sp=new URLSearchParams(data);
  for(let [n,v] of sp.entries())
    switch(n)
	{ case 'type':  for(let t of v.split(','))   filter[n+'['+t+']'].checked=true;
                   	custom_types.selected=true;
					on_class_change();
            		break;  
	  case 'start_date': filter.start.value='';	  		  
	                     on_start_name_change();
						 filter[n].value=v;
						 break;
	  case 'class': 	 filter[n].value=v;
	                     on_class_change();  
						 break; 	                   					 

      case 'user':       filter[n].value=v;
	                     photo.src="photo.php?num="+v;
	                     var fd=new FormData;
                         fd.set('num', v);
                         var xhr = new XMLHttpRequest;
                         xhr.open('POST', 'filt_users.php?type=user', false);
                         xhr.send(fd);
                         if(xhr.status==200)  
                         { userlist.innerHTML = xhr.responseText;   
						   if(op=userlist.querySelector(':scope option'))
   						     username.value=op.value;	      						   
						 }
                         else alert(xhr.responseText);                      	                      
	                     break;	                     
	  					 
	  default:
          n=filter[n];
		  if(n.tagName=='INPUT' && n.type=='checkbox')
                 n.checked=true; 
            else n.value=v;					 					  		        
	 }
}

<?php
if($sidf=$sid_filter->get('')) 
 echo "document.addEventListener('DOMContentLoaded', function() {select_filter('$sidf');});";
?> 
</script>



</body>  
</html>  