<?php
include_once "elacset.php"; 
include_once "WF3.php"; 
include_once 'photonorm.php';
assert_req_right();

new class extends TDataset
{
 protected $autosort=true; 

 function init()
 {   
  $this->fields=
  [
    new class extends GenIntField
    { public $name = 'NUM'; 
 	  public $data= true;
	  public $generator='gen_users';
    },

    new class extends StringField
    { public $name = 'USERNAME';
      public $caption = '';  
  	  public $size=64;	  
    },  
	
    new class extends IntField
    { public $name = 'USERGROUP';
      public $required=false;
    }, 	
	
    new class extends StringField
    { public $name = 'GROUPNAME';
      public $caption = '';  
    },  

    new class extends StringField
    { public $name = 'ORG';
      public $caption = '';  
    },  
    new class extends IntField
    { public $name = 'TAB_NUMBER'; 
      public $caption = ' ';
	  public $title = '   ';
    },
    new class extends LookupField
	{
	  public $name = 'DOC_TYPE'; 
	  public $caption = '';
	  
	  function __construct()
	  { $this->list=$GLOBALS['guest_doc_types']; }
	},

    new class extends StringField
    { public $name = 'PRIM';
 	  public $caption = '';
  	  public $size=255;	  
	  public $required=false;
	},  
	
    new class extends TField
    { public $name = 'PHOTO'; 
      public $required=false;	
	  
      function parse($v)
      { if($v=='') return null;  
	    $ph=NormalizePhoto(imagecreatefromstring($v));
   	    ob_start();
        imagejpeg($ph);
        return ob_get_clean();	    
	  }  	  
    },		

	
    new class extends StringField
    { public $name = 'DATA';
  	  public $size=255;	  
	  public $required=false;
    }	
		
  ];
  
  $this->set_visible(['USERNAME', 'GROUPNAME', 'ORG', 'TAB_NUMBER', 'DOC_TYPE']);  
					
  $this->set_notreadonly(['NUM', 'USERNAME', 'USERGROUP', 'PRIM', 'DATA']);
  
  
  $sel=             'select u.num, u.username, g.groupname, d1.data_value as org, o.tab_number, d10.data_value as doc_type
                     from USERS u
  				     join DW_USER_STATES s on u.num=s.user_ref and s.workflow=0 and s.state=1
 					 left join D_GUEST_DATA d1 on d1.guest=u.num and d1.data_type=1
					 left join D_GUEST_DATA d10 on d10.guest=u.num and d10.data_type=10					 
					 left join D_OWNERS o on u.num=o.user_ref
					 left join GROUPS g on g.num=u.usergroup';
					 
  $this->select_sql =$sel;//. ' order by u.username';
  $this->refresh_sql=$sel. ' where u.num=:num';					 
					
  $this->delete_sql='delete from USERS where num=:num';
					 
  $this->update_sql=['update USERS set  username = :username, usergroup = :usergroup,  prim=:prim where  num = :num',
                     'delete from D_GUEST_DATA where guest = :num' 
                    ];
					  
  $this->insert_sql=['insert into USERS (num, username,  usergroup,  photo,  prim)  values (:num, :username, :usergroup, :photo, :prim)',
					 'insert into DW_USER_STATES (user_ref,workflow,state) values (:num,0,1)',
					 'insert into DW_USER_STATES (user_ref,workflow,state) values (:num,3,0)',					  
                    ];					  
					 
 } //init


function before_update($params) 
{
  if(isset($params['SETPHOTO']))
   $this->update_sql[]='update USERS set photo=:photo where num = :num';
}
 
function update_also($params) 
{ 
  $this->insert_also($params);
}

function validate_also($params, $action)
{
 if($this->db->query("select guest_required_doc from D_SETTINGS")->fetchColumn() && empty($params['DATA'][10]))
   throw new Exception("  ");
}
 
function insert_also($params)
{
 foreach($params['DATA'] as $type=>$value)
  if(!empty($value))
   $this->db->prepare('insert into D_GUEST_DATA (guest, data_type, data_value)  values( :num, :type,  :value)')
            ->execute([ $params['NUM'],  $type,  $value ] );
}  
 
protected $error_map = ['D_OWNERS_FKU' => ' .   .'];

 
};