<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_HARDWARE); 

function in_out($i)
{ return (intdiv($i,2)+1).'.'.($i%2+1); }


$TableH = new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'COMPUTER'; 
 	  public $visible= false;
    },
    new class extends IntField
    { public $name = 'ADR';
 	  public $visible= false;
    },
    new class extends IntField
    { public $name = 'NUM';
      public $data = true;   
	  public $names = ['update' => 'NEWNUM'];
	  public $caption = '';
	  public $title = '  ';
	  public $max=127;
    },	
	
    new class extends LookupField
	{ public $name = 'EVENT_TYPE';
      public $caption = '';
	
	  public $optgroups=
	  [
	    ['', [
		0x00=>'']],
		
	    ['', [
        0x11=>'  ',
        0x12=>'  ',
        0x13=>'  ',
        0x14=>'  ',
        0x15=>'  ',
        0x16=>' ',
        0x17=>' ']],

	    ['', [
        0x21=>' ',
        0x22=>'    ',
        0x23=>'  -  ',
        0x24=>'    ',
        0x25=>'  ',
        0x26=>' ',
        0x27=>' ',
        0x28=>'  ',
        0x29=>'  ',
        0x2A=>'   ',
        0x2B=>'   ']],

	    ['', [		
        0x2C=>'  n']],

	    ['', [
        0x31=>' ',
        0x32=>' ',
        0x33=>'  ',
        0x34=>'  ',
        0x35=>'  ',
        0x36=>'  ',
        0x37=>'     ',
        0x38=>'     ',
        0x39=>'  ',
        0x3A=>'  ',
        0x3B=>'     ',
        0x3C=>'     ',
        0x3D=>' ',
        0x3E=>' ',
        0x3F=>'    ()',
        0x41=>'  INx.x',
        0x42=>'  INx.x',
        0x43=>'  DATAx.x',
        0x44=>'  DATAx.x']],

	    ['', [
        0x51=>'  ',
        0x52=>'   ',
        0x53=>'    ',
        0x54=>'  ',
        0x55=>'   ',
        0x56=>'    ',
        0x57=>'    ',
        0x58=>'   ',
        0x59=>'    ',
        0x5A=>'     ',
        0x5B=>'     ',
        0x5C=>'   ',
        0x5D=>'    ',
        0x61=>'   ',
        0x62=>'   ',
        0x63=>'   ',
        0x64=>'   ',
        0x65=>'     ',
        0x66=>'     ',
        0x67=>'  ',
        0x68=>'  ',
        0x69=>'  ',
        0x6A=>'  ',
        0x6B=>'  ',
        0x6C=>'  ']],

	    ['', [
        0x71=>'  ',
        0x72=>'  ',
        0x73=>'  ',
        0x74=>'  ',
        0x75=>'   ',
        0x76=>'      ',
        0x77=>'    ',
        0x78=>'     ',
        0x79=>' ',
        0x7A=>' ',
        0x7B=>'  ',
        0x7C=>'  ']],

	    ['', [
        0x81=>'  ',
        0x82=>'  ',
        0x83=>'  ',
        0x84=>'    ',
        0x85=>'   ',
        0x86=>'  ',
        0x87=>'   ',
        0x88=>'  ',
        0x89=>'  ',
        0x91=>' ',
        0x92=>'   ',
        0x93=>'    ',
        0x94=>'     ',
        0x95=>'     ',
        0x97=>'   ',
        0x98=>'   ',
        0x99=>'     ',
        0x9A=>' ',
        0x9B=>'  ',
        0x9C=>'    ',
        0x9D=>'   ']],

	    ['', [
        0xA1=>'  ',
        0xA2=>'    ',
        0xA3=>'   ',
        0xA4=>'  ',
        0xA5=>'   ',
        0xA6=>' ',
        0xA7=>'  ',
        0xA8=>'   ',
        0xA9=>'    ',
        0xAA=>'   ']]
	  ];
    },
	
    new class extends IntField
    { public $name = 'PARAM';
	  public $caption = '';
	  public $max=255;
	  public $required=false;
    },		
	
    new class extends LookupField
	{ public $name = 'CONDITION';
      public $caption = '';
	
	  function __construct()
	  {
	    $l=[];
	    $l[0x00]="";
		$this->optgroups[]=[null, $l]; $l=[];
		
        for($i=0; $i<2; $i++) $l[0x10+$i]=" $i ";
        for($i=0; $i<2; $i++) $l[0x14+$i]=" $i ";
		$this->optgroups[]=[' ', $l]; $l=[];
		
	 	for($i=0; $i<2; $i++) $l[0x12+$i]="   $i ";      
        for($i=0; $i<2; $i++) $l[0x16+$i]="   $i ";      
		$this->optgroups[]=['', $l]; $l=[];
		
		for($i=0; $i<2; $i++) $l[0x18+$i]=" $i    c";      
		for($i=0; $i<2; $i++) $l[0x1A+$i]=" $i    c";      
		for($i=0; $i<2; $i++) $l[0x1C+$i]=" $i    c";      		
		for($i=0; $i<2; $i++) $l[0x1E+$i]=" $i    c";      				
		$this->optgroups[]=['', $l]; $l=[];
		
    	for($i=0; $i<2; $i++) $l[0x20+$i]=" $i   ";      				
     	for($i=0; $i<2; $i++) $l[0x24+$i]=" $i ";      				
     	for($i=0; $i<2; $i++) $l[0x28+$i]=" $i ";      						
		$this->optgroups[]=[' ', $l]; $l=[];
		
		$l[0x30]="   ";
		$l[0x34]="  ";
		$l[0x38]="   ";
    	$l[0x3C]="  ";
		$this->optgroups[]=['', $l]; $l=[];
		
     	for($i=0; $i<4; $i++) $l[0x40+$i]="    IN".in_out($i);      						
     	for($i=0; $i<4; $i++) $l[0x44+$i]="    IN".in_out($i);      						
		$this->optgroups[]=['', $l]; $l=[];

		$l[0x48]="   ";
        $l[0x4C]="  ";
		$this->optgroups[]=['', $l]; $l=[];
		
        $l[0x50]="    ";
        $l[0x54]="   ";
		$this->optgroups[]=['', $l]; $l=[];

        for($i=0; $i<4; $i++) $l[0x60+$i]=" ".($i+1)." ";
        for($i=0; $i<4; $i++) $l[0x64+$i]=" ".($i+1)." ";		
		$this->optgroups[]=['', $l]; $l=[];
		
        for($i=0; $i<4; $i++) $l[0x68+$i]=" OUT".in_out($i)." ";		
		for($i=0; $i<4; $i++) $l[0x6C+$i]=" OUT".in_out($i)." ";		
		$this->optgroups[]=['', $l]; $l=[];
		
		for($i=0; $i<2; $i++) $l[0x70+$i]="     $i";
		for($i=0; $i<2; $i++) $l[0x74+$i]="     $i";
		$this->optgroups[]=['', $l]; $l=[];
		
		for($i=0; $i<8; $i++) $l[0x80+$i]="   $i";
		for($i=0; $i<8; $i++) $l[0x88+$i]="   $i";
		for($i=0; $i<4; $i++) $l[0x90+$i]="  $i";
		for($i=0; $i<4; $i++) $l[0x94+$i]="  $i";		
		$this->optgroups[]=['', $l]; $l=[];
		
		for($i=0; $i<8; $i++) $l[0xA0+$i]=" $i ";
		for($i=0; $i<8; $i++) $l[0xA8+$i]=" $i ";		
		$this->optgroups[]=['', $l]; $l=[];
		
		for($i=0; $i<4; $i++) $l[0xB0+$i]=" DATA".in_out($i)."   ";
        for($i=0; $i<4; $i++) $l[0xB4+$i]=" DATA".in_out($i)."   ";		
		$this->optgroups[]=['DATA', $l]; $l=[];
		
        for($i=0; $i<2; $i++) $l[0xB8+$i]=" LED$i   ";
        for($i=0; $i<2; $i++) $l[0xBA+$i]=" LED$i   ";		
		$this->optgroups[]=['LED', $l]; $l=[];
		
        for($i=0; $i<2; $i++) $l[0xBC+$i]=" ZUM$i   ";		
		for($i=0; $i<2; $i++) $l[0xBE+$i]=" ZUM$i   ";		
		$this->optgroups[]=['ZUM', $l]; $l=[];
	  }
	},	
    new class extends LookupField
	{ public $name = 'REACTION';
	  public $caption = '';
	  
	  function __construct()
	  { $l=[];	    
        for($i=0; $i<4; $i++) $l[0x10+$i]="  ".($i+1);
		for($i=0; $i<4; $i++) $l[0x14+$i]="  ".($i+1);
		for($i=0; $i<4; $i++) $l[0x18+$i]="  OUT".in_out($i);
		for($i=0; $i<4; $i++) $l[0x1C+$i]="  OUT".in_out($i);
		$this->optgroups[]=['', $l]; $l=[];

		for($i=0; $i<8; $i++) $l[0x20+$i]="  $i";
		for($i=0; $i<8; $i++) $l[0x28+$i]="  $i";		
    	$this->optgroups[]=['', $l]; $l=[];

		for($i=0; $i<16; $i++) $l[0x30+$i]="C $i";
		$this->optgroups[]=['', $l]; $l=[];
		
        for($i=0; $i<8; $i++) $l[0x40+$i]="   $i"; 
		for($i=0; $i<8; $i++) $l[0x48+$i]="   $i"; 
     	$this->optgroups[]=['', $l]; $l=[];
		
		for($i=0; $i<2; $i++) $l[0x50+$i]=" .  $i";		
		for($i=0; $i<2; $i++) $l[0x52+$i]=" .  $i";
		$this->optgroups[]=['', $l]; $l=[];
		
		for($i=0; $i<2; $i++) $l[0x54+$i]=" .  $i";
		for($i=0; $i<2; $i++) $l[0x56+$i]=" .  $i";
    	$this->optgroups[]=['', $l]; $l=[];
		
        for($i=0; $i<2; $i++) $l[0x58+$i]="  LED$i";				
		for($i=0; $i<2; $i++) $l[0x5A+$i]="  LED$i";		
    	$this->optgroups[]=['LED', $l]; $l=[];
		
		for($i=0; $i<2; $i++) $l[0x5C+$i]="  ZUM$i";		
		for($i=0; $i<2; $i++) $l[0x5E+$i]="  ZUM$i";		
		$this->optgroups[]=['ZUM', $l]; $l=[];
		
		for($i=0; $i<4; $i++) $l[0x60+$i]="  $i";		
		for($i=0; $i<4; $i++) $l[0x64+$i]="  $i";		
		for($i=0; $i<4; $i++) $l[0x68+$i]="  $i";		
		$this->optgroups[]=['', $l]; $l=[];
		
		$l[0x6C]=" ";
		$l[0x6D]="   ";
		$this->optgroups[]=['', $l]; $l=[];
	  }
	}  	
  ];
  
 
  $sel='select * from D5_HANDLERS where computer=:computer and adr=:adr';
  $this->select_sql =$sel.' order by num';   
  $this->refresh_sql=$sel.' and num=:num';
 }  
 
 public $insert_sql=
'insert into D5_HANDLERS(adr, computer, num, param, condition, reaction, event_type)
 values(:ADR, :COMPUTER, :num, :param, :condition, :reaction, :event_type)';

public $update_sql=
'update D5_HANDLERS set 
    num = :newnum,
    param = :param,
    condition = :condition,
    reaction = :reaction,
    event_type = :event_type
 where  adr = :adr and computer = :computer  and num = :num';

public $delete_sql='delete from D5_HANDLERS  where   adr = :adr  and computer = :computer  and num = :num';   
  

 function default_row($params)
 { return 
   [ 'NUM' => $this->prepare_execute('select max(num)+1 from D5_HANDLERS where adr = :adr and computer = :computer', $params)->fetchColumn() ?: 0 ];
 } 

 protected $error_map=['D5_HANDLERS_PK' => '    ',
                       'D5_HANDLERS_FKD' => '   '];  

  
 function on_export($params)  
 {
   $data=[];		 
   foreach($this->prepare_execute($this->select_sql,$params) as $h)
    array_push($data, $h["NUM"], $h["EVENT_TYPE"], $h["PARAM"] ?? 0,  $h["CONDITION"], $h["REACTION"]);

   echo "<tr data-export='",implode(',',$data),"'></tr>";		 
 }
 
 
 function on_import($params)  
 { $this->prepare_execute('delete from D5_HANDLERS where adr = :adr and computer = :computer', $params);   

  $hdl=$_FILES['hdl'];  
  if($hdl['size']>5*256 || $hdl['size'] % 5) fail('  ');
  
  $h =fopen($hdl['tmp_name'], 'r');
  if(!$h)  fail('  ');
  unset($params['HDL']);
  
  $q=$this->db->prepare($this->insert_sql);
  
  while($buf=fread($h, 5))
  {
   $d=unpack('C5', $buf);     
   $params['num']=$d[1];
   $params['event_type']=$d[2];
   $params['param']=$d[3];
   $params['condition']=$d[4];
   $params['reaction']=$d[5];  
   $q->execute($params);
  }
  fclose($h);    
  $this->on_select($params);
 } 
 
 
 function on_store($params)  
 {
  $params['text']='el05_handlers';
  $this->prepare_execute("insert into d_commands (executor,phis_addr,text) values (:computer,:adr,:text)", $params);
 } 
}; 