<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_HOLIDAYS);


new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends TField
    { public $name = 'H_DATA';
	  public $names = ['update' => 'NEW_DATA'];
	  public $data=true;	
      public $caption = '';  
	  
      function make_edit_attr(&$at)
      { $at['type']='text';
	    $at['placeholder']='.';
      	$at['maxlength']=5;  
      }
	  
      function get_data_text($v) 
	  { $dt = new DateTime($v);
        return $dt->format('d.m');
	  }
	  
	  function draw_text($v, $row)   { if($v) echo $this->get_data_text($v); }  
	  
      function parse($v)
	  { 
	    if($dt=DateTime::createFromFormat('d.m.Y', $v.'.2000'))
	         return $dt->format('d.m.Y');
		else throw new Exception("  ");  
	  }
    },	
    new class extends BoolField
    { public $name = 'HOL1';
      public $caption = '';  
	  public $default = 1;
    },	
    new class extends BoolField
    { public $name = 'HOL2';
      public $caption = '';  
    },	
    new class extends StringField
    { public $name = 'H_NAME';
      public $caption = ' ';  
  	  public $size=63;	
	  public $required=false;	    
    }	
  ];   

  $this->select_sql ='select * from D_HOLIDAY order by h_data';   
  $this->refresh_sql='select * from D_HOLIDAY where h_data=:h_data'; 
  $this->delete_sql ='delete from D_HOLIDAY where h_data = :h_data';
  $this->update_sql ='update d_holiday set h_data = :new_data,  h_name = :h_name,  hol1 = :hol1,  hol2 = :hol2 where  h_data = :h_data';
  $this->insert_sql ='insert into D_HOLIDAY (h_data, h_name, hol1, hol2) values (:h_data, :h_name, :hol1, :hol2)'; 
 }

 
protected $error_map = ['D_HOLIDAY_PRKEY' => '  '];  
 
 
 }; //TDataset 