<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_ACCESSLEVELS);

new class extends TDataset
{
 
 protected $autosort=true; 

 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'A_LEVEL'; 
      public $caption = '';
	  public $min=1;
 	  public $data= true;	  
	  public $names = ['update' => 'NEWID',
	                   'insert' => 'NEWID',
					   'copy' =>   'NEWID'
	                  ];  
					  
	  function get_default($action)	 			  
	  { return $this->dataset->db->query('select max(A_LEVEL) from D_ACCESS_LEVELS')->fetchColumn()+1;	  }
	  
  
	  function restrict($v, $action)
	  { assert_right(RT_LEVELS, $v);  }
    },

    new class extends StringField
    { public $name = 'A_NAME';
      public $caption = '  ';  
  	  public $size=64;	  
    }	
  ];   
  
  $this->select_sql ='select * from D_ACCESS_LEVELS'.sql_where(' where a_level',RT_LEVELS);   
  $this->refresh_sql='select * from D_ACCESS_LEVELS where a_level=:a_level';
  $this->delete_sql ='delete   from D_ACCESS_LEVELS where a_level=:a_level';   
  $this->update_sql ='update D_ACCESS_LEVELS set a_level=:newid, a_name=:a_name where a_level=:a_level';
  $this->insert_sql ='insert into D_ACCESS_LEVELS (a_level, a_name) values (:newid, :a_name)'; 
 }
 
 
 function on_copy($params) //a_level, a_name
 { 
   $this->prepare_input_params($params, 'copy');
   $this->prepare_execute($this->insert_sql, $params);
  
   $this->prepare_execute("delete from D_ACCESS_ZONES where access_level=:newid", $params);
   
   $this->prepare_execute("insert into D_ACCESS_ZONES (access_level,reader,zone) 
                           select :newid,reader,zone from D_ACCESS_ZONES where access_level=:a_level", $params);
						   
   $this->reload($params, 'copy');
} 

protected $error_map = 
             ['D_ACC_LEVEL_PK'        => '     ',  
              'D_DEFERRED_LEVELS_FKL' => '      ',
			  'D_OWNER_LEVELS_FKL'    => '     ',
			  'FOREIGN KEY'           => '  '  
             ];

} //TDataset



?> 