<?php
namespace ElAcMenu; 
include('menutree.php');
include_once('reports.php');
include('workflow.php');

$builder = new \TreeMenuBuilder;




function mnode($name, $img)  { global $builder;  $builder->node($name, $img);  }
function mend(){ global $builder;  $builder->end(); }
function madd($name, $img, $uri = '#/', $visible=true, $attr='') 
{ global $builder; 
  $builder->add($name, $img, $uri, $visible, $attr); 
 }

function r($right_id, $right_type=RT_FUNCTIONS)
{ return has_right($right_type, $right_id); }



mnode('', 62);
  madd('', 62, 'users.php', r(RI_USERS));
  madd('', 59, 'groups.php', r(RI_SYSTEM) || r(RI_GROUPS));
  foreach($workflows as $w)  
    if(method_exists($w, 'CreateUsersMenu'))
      $w->CreateUsersMenu($builder);  
  madd(' ',5,'props.php', r(RI_SYSTEM));
mend();

mnode('', 28);
  foreach(load_reports() as [$rpt, $file])
    madd($rpt->name, 28 , $file, r(RI_REPORTS) && r($rpt->id,RT_WEBREPORTS), isset($rpt->description) ? "title='$rpt->description'" : '');
mend();


mnode('', 5);
  mnode('', 33);
    madd('', 19, 'computers.php', r(RI_HARDWARE));      
	madd('', 26, 'readers.php', r(RI_HARDWARE));      	
	  mnode('', 5);
    	madd('', 19, 'comp_set.php', r(RI_HARDWARE));
   	    madd('', 26, 'el05_glob.php', r(RI_HARDWARE));
    	madd('', 3, 'handlers.php', r(RI_HARDWARE));      	
        madd('', 3, 'vm.php', r(RI_HARDWARE));      		   
	  mend();	  
    madd('', 24, 'terr.php', r(RI_HARDWARE));      			
	madd(' ' , 36, 'ctypes.php', r(RI_HARDWARE));
    madd(' ', 55 , 'open.php' , r(RI_OPEN_DOOR));
    madd('', 27, 'diag.php', r(RI_DIAG));    
  mend();

  mnode('', 10);
    madd(' ', 10, 'levels.php', r(RI_ACCESSLEVELS));    
    madd(' ', 11, 'timezones.php', r(RI_TIMEZONES));    
	madd('', 9, 'holidays.php', r(RI_HOLIDAYS));    	
    madd(''    , 11, 'smena.php', r(RI_TIMEZONES));
	madd(' ', 45 , 'graph.php' , r(RI_SMENA_GRAPHICS));	
    madd(" ", 31, 'wmode.php',  r(RI_WORK_MODES));
    madd('', 60 , 'apb.php' , r(RI_APB));
    madd('', 25 ,'opers.php', r(RI_OPERATORS));	
  mend();

  mnode('', 5);  
    madd(" ", 20, 'dbclear.php', r(RI_CLEARBASE));    
	madd("", 21, 'stat.php', r(RI_SYSTEM));
  mend();
  
/*  mnode(' ', 22);
    madd('',23, 'server.php?page=0', r(RI_SYSTEM));
	madd('Backup ',23, 'server.php?page=1', r(RI_SYSTEM));
	madd('Restore ',23, 'server.php?page=2', r(RI_SYSTEM));
	madd(' ',23, 'server.php?page=3', r(RI_SYSTEM));
    madd('',23, 'server.php?page=4', r(RI_SYSTEM));	
  mend();  */
  
  madd(' ', 32, 'changepass.php', r(RI_CHANGEPASSWORD));
  madd(' ', 63, 'about.php', r(RI_SYSTEM));
mend();

mnode('', 52, r(RI_HELP));
mend();


mnode('', 15);
  madd(' ', 15, 'events.php', r(RI_EVENTSBASE));
  madd(' ', 14, 'filter.php', r(RI_EVENTSBASE));  

  madd(' ', 18, 'event_types.php', r(RI_EVENTSBASE));
  madd('',  12, 'photoid.php', r(RI_PHOTOID));
  madd(' ', 13, 'notify.php', r(RI_MONITORING));
  
  mnode('', 53);
    foreach($db->query("select id,name,data from D_FILTERS where editor=$editor".sql_where(" OR id",RT_EVENT_FILTERS)." order by name") as [$id, $name, $data])
	 if(ctype_print($data)) //skip desktop maid filters 
	 { parse_str($data, $filter_query);
	   if(isset($filter_query['newwin']))	   
            madd($name, 53, "events.php?filter=$id&nomenu", true, 'target=_blank');
   	   else madd($name, 53, "events.php?filter=$id");	  
	 }  
  mend();	
mend();


unset($builder);
?> 