<?php
include_once "elacset.php"; 
include_once "password.php"; 

assert_right(RT_FUNCTIONS, RI_OPERATORS); 

new class extends TDataset
{
 function init()
 {
  $this->fields=
  [
    new class extends GenIntField
    { public $name = 'EDITOR'; 
 	  public $visible= false;
	  public $data=true;
	  public $generator='D_GEN_OPERATORS';
    },

    new class extends IntField
    { public $name = 'EDITOR_NUM'; 
      public $caption = '';  
	  
	  function get_default($action)
	  { return $this->dataset->db->query('select max(editor_num) from D_EDITOR_SETTINGS')->fetchColumn()+1; }	  
    },
	
    new class extends StringField
    { public $name = 'EDITOR_NAME'; 
      public $caption = '';  
  	  public $size=50;	
    },
	
    new class extends BoolField
    { public $name = 'ACTIVED';
      public $caption = '';  
	  public $title = '';  
	  public $default = 1;
    }
  ];
  
  $sel = 'select editor, editor_name, actived,editor_num from D_EDITOR_SETTINGS ';
  $this->select_sql  = $sel.sql_where("where EDITOR",RT_OPERATORS).' order by EDITOR_NUM';
  $this->refresh_sql = $sel.'where editor=:editor';
  
  $this->update_sql = 'update D_EDITOR_SETTINGS set  editor_name = :editor_name, actived = :actived, editor_num = :editor_num
                       where  editor = :editor';
  
  $this->delete_sql = 'delete from D_EDITOR_SETTINGS where editor = :editor';
  
  $this->insert_sql = 'insert into D_EDITOR_SETTINGS(editor,  editor_name, actived, hash_password, hash2, editor_num)
                                              values(:editor,:editor_name,:actived,:hash_password,:hash2,:editor_num)';
 }
 
 function on_insert($params)
 {
   $params['HASH_PASSWORD'] = HashPassword('') ; 
   $params['HASH2']=HashPassword2('') ; 
   parent::on_insert($params);
 }
 
 function get_tr_classes($row)
 { if($row['EDITOR']==1)  return ['row-readonly'];  } 
 
 
 
 function on_copy($params) //$params: editor, editor_name
 { 
   $params['OLD_EDITOR'] = $params['EDITOR'];
   $params['EDITOR'] = $this->fields[0]->gen_id();
   $params['ACTIVED'] = 1;
   $this->on_insert($params);

   $this->prepare_execute("insert into D_EDITOR_RIGHTS (EDITOR,RIGHT_TYPE,RIGHT_ID) 
                           select :editor,RIGHT_TYPE,RIGHT_ID from D_EDITOR_RIGHTS where EDITOR=:old_editor", $params);
 } 
  
 
 function on_password($params) //$params: editor, password 
 { assert_right(RT_OPERATORS, $params['EDITOR']);
   if($params['EDITOR']==1) throw new Exception($error_map['E_INVALID_OPERATOREDIT']);
   
   $params['HASH_PASSWORD'] = HashPassword($params['password']) ; 
   $params['HASH2']=HashPassword2($params['PASSWORD']);   
   $this->prepare_execute('update D_EDITOR_SETTINGS set  hash_password=:hash_password, hash2=:hash2 where  editor = :editor', $params); 
   global $editor;
   $this->db->exec("insert into events (event_type,param1,param2) values (129,$params[EDITOR],$editor)");   
 } 
 
 function exec_action($action, $params)
 { 
  if($e = $params['EDITOR'] ?? false)  
  { assert_right(RT_OPERATORS, $e);
    if($e==1) throw new Exception($error_map['E_INVALID_OPERATOREDIT']);
  }
  
  if($action=='delete' &&
     $action=='insert') assert_right(RT_RIGHTS,RR_NEW_OPERATOR); 
  
  parent::exec_action($action, $params); 
 }		 
 

protected $error_map =  ['D_EDITOR_SETTINGS_UNUM' => '    ',
                         'E_INVALID_OPERATOREDIT' => '   '  
                        ];
 
 
}; 