<?php 
//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------
class d_option
{
 public $table;
 public $db;
 private $editor;
 private $name;
 private $default;
 
 function __construct($name, $def=null, $editor=-1) 
 { $this->editor = $editor;
   $this->name = $name; 
   $this->default=$def;
   global $db;
   $this->db=$db;
   $this->table = $db::options_table;
 }
 
 function get($def=null)
 { 
   $r=$this->db->query("select option_value from $this->table where editor=$this->editor and option_name='$this->name'")->fetch(PDO::FETCH_NUM); 
   return $r ? $r[0] : ($def ?? $this->default); 
 }
 
 function set($v)
 { 
   $q=$this->db->prepare("update $this->table set option_value=? where editor=? and option_name=?"); 
   $q->execute([$v, $this->editor, $this->name]); 

   if(!$q->rowCount())
   { $q=$this->db->prepare("insert into $this->table (option_value, editor, option_name) values (?, ?, ?)");
     $q->execute([$v, $this->editor, $this->name]); 
   }   
 } 
 
 function get_blob()
 { return $this->db->query("select option_blob from $this->table where editor=$this->editor and option_name='$this->name'")->fetchColumn();  }
 
 function set_blob($v)
 { 
   $q=$this->db->prepare("update $this->table set option_blob=? where editor=? and option_name=?"); 
   $q->execute([$v, $this->editor, $this->name]); 

   if(!$q->rowCount())
   { $q=$this->db->prepare("insert into $this->table (option_value, editor, option_name) values (?, ?, ?)");
     $q->execute([$v, $this->editor, $this->name]); 
   }   
 } 
 
 function clear()
 { $this->db->query("delete from $this->table where editor=$this->editor and option_name='$this->name'"); }

} //d_option
//----------------------------------------------------------------------------------------

class d_editor_option extends d_option
{
 function __construct($name, $def=null) 
 { global $editor;
   parent::__construct($name, $def, $editor);
 }
}
//----------------------------------------------------------------------------------------
//  web 
//    $editor_sid
class d_sid_option 
{
 public $table;
 public $db;
 private $name;
 private $sid;
 
 function __construct($name) 
 { $this->name = $name;
   global $db, $editor_sid;
   $this->sid=$editor_sid;
   $this->db=$db;
   $this->table = $db::sid_options_table;
 }
 
 function get($def=null)
 { $r=$this->db->query("select data from $this->table where sid='$this->sid' and name='$this->name'")->fetch(PDO::FETCH_NUM); 
   return $r ? $r[0] : $def; 
 }
 
 function set($v)
 { 
   $q=$this->db->prepare("update $this->table set data=? where sid=? and name=?"); 
   $q->execute([$v, $this->sid, $this->name]); 

   if(!$q->rowCount())
   { $q=$this->db->prepare("insert into $this->table (data, sid, name) values (?, ?, ?)");
     $q->execute([$v, $this->sid, $this->name]); 
   }   
 } 
 
 function clear()
 { $this->db->query("delete from $this->table where sid='$this->sid' and name='$this->name'");  } 
 
}
//----------------------------------------------------------------------------------------


function post_options($opts)
{ 
  foreach($GLOBALS[$opts] as $key=>$op)
   if(($v=$_POST[$opts][$key] ?? '')=='')
         $op->clear();
   else	 $op->set($v);
}
