<?php 
include "form.php"; 
include "options.php"; 
include 'phid_opt.php';
include_once("servmod.php");

assert_right(RT_FUNCTIONS, RI_PHOTOID); 


$X = intval($opts['X']->get());
$Y = intval($opts['Y']->get());
$R = floatval($opts['R']->get());
?>

<link rel="icon" href="img/12.png">

<script>
const photoid_delay=<? echo $db->query("select photoid_delay from D_EDITOR_SETTINGS where editor=$editor")->fetchColumn()*1000 ?>;

const computers=[
<?
$comps = []; 
foreach($db->query("select d.computer, d.reader from D_PHOTOID_READERS i,D_DEVICES d
                    where i.editor_ref=$editor and i.reader_ref=d.reader") as $row)
 $comps[$row[0]][]=$row[1];

$names = []; //
 
foreach($comps as $comp=>$rlist)
{
  $row=$db->query("select inetaddr,name from COMPUTERS where computer=$comp")->fetch(); 
  $names[$comp]=$row[1];
  echo "{ computer: $comp, name: '$row[1]', url: 'ws://$row[0]:$phmodule_port/web/photoid?readers=",implode(',', $rlist),"'},\r\n";
}
?>
];

function check_states()
{ states.style.display='none';
  for(comp of computers) 
  { document.getElementById("state"+comp.computer).dataset.state=comp.wsocket.readyState;
    if(comp.wsocket.readyState==3) states.style.display='block';
  }
}

function reconnect()
{
 for(comp of computers) 
  if(!comp.wsocket || comp.wsocket.readyState==3)
  {  comp.wsocket = new WebSocket(comp.url+"&"+get_sid());
     comp.wsocket.onmessage = do_photoid;  
	 comp.wsocket.onopen  = check_states;
	 comp.wsocket.onclose = check_states;
  }
}


var photoid_counter=1;

function do_photoid(event)
{
  var win=photoid.querySelector(':scope>div:empty');
  if(!win)
  { let m=null;
    for(let n of photoid.querySelector(':scope>div'))
      if(!m || n.photoid_counter<=m)
	   { m=n.photoid_counter;
	     win=n;
	   }	  
    clearTimeout(win.photoid_timer);
  }

  var xhr = new XMLHttpRequest();
  xhr.open('GET', 'phid_draw.php?'+event.data, false);
  xhr.send();
  win.innerHTML=xhr.responseText;    
  
  win.photoid_counter=photoid_counter++;
  win.photoid_timer=setTimeout( function() { win.innerHTML='';}, photoid_delay);   
}


reconnect();
setInterval(reconnect, 20000);
</script>



<style>

#workarea {display: flex}

#photoid
{ position: relative;
  width: <? echo round(100*$X/$Y/$R) ?>vh;
  height: 100%; 
  display: inline-grid;
  gap: 1px;
  border: 1px solid black;
  background-color: black;
  grid-template-columns:  repeat(<? echo $X ?>, 1fr);
  grid-template-rows:     repeat(<? echo $Y ?>, 1fr);  
  flex: none;
}

#events { flex: 1 1;
          border: none; }

:fullscreen #btncfg { display: none; } 
		  
#btncfg
{ position: absolute;
  left: 0;
  bottom: 0;
}

#photoid>div
{ background-color: var(--tables-background);
  display: flex;
  flex-direction: column;
}

#photoid input
{ width: 50%; } 

#photoid [name='USERNAME']
{ font-weight: bold;
  width: 100%;
}

#photoid input:last-child:nth-child(even)
{ width: 100%; } 

#photoid [name='COLOR']
{ flex: 1; 
  position: relative; 
}
 
#photoid>div>div:first-child { flex: 0; }

#photoid [name='PHOTO']
{ max-height: 95%;
  max-width: 95%;
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%,-50%);
}

#states { align-self: start;
		  border: 1px solid black; 
		  display: none;}

#states>div:first-child { text-align: center;
                          font-weight: bold;  }		 
#states [data-state='1'] {background-color: var(--GlobalGreen); }
#states [data-state='3'] {background-color: var(--GlobalRed); }		

</style>



<title></title>

</head>
<body id=workarea>

<div id=photoid>
<? for($i=0; $i<$X*$Y; $i++) echo "<div></div>"; ?>
<a id=btncfg class=ToolBtn title=" " href="phid_cfg.php"><img src="img/5.png"></a>
</div> <!-- photoid -->

<div id=states>
<div> </div>
<?
foreach($names as $comp=>$name)
echo "<div id=state$comp>$name</div>"
?>
</div>

<? if($opts['EV']->get()) { ?> <iframe id=events src="events.php?iframe&live"></iframe> <? } ?>


<? if($config_ini['DemoMode'] ?? 0) { ?>

<script>
function on_demo_photo_id()
{ const readers=[2,3];
  const cards=[<? foreach($db->query('select card_code from D_OWNERS') as $row) echo "'$row[0]'," ?> ];
  do_photoid({data: 'reader='+readers[Math.floor(Math.random() * readers.length)]+'&card='+cards[Math.floor(Math.random() * cards.length)]});
}


setTimeout(on_demo_photo_id, 1000);
setInterval(on_demo_photo_id, 5000);
</script>
<? } ?>

<!-- <button onclick="do_photoid('reader=9&card=AB2356')">Test</button>  -->
</body> <!-- workarea -->
</html>  