<?php
include_once("login.php"); 
include_once("options.php"); 


const PhotoHeight=473,
      PhotoWidth =354;

const rotate_method_mask=3,
      rotate_zero=0,
	  rotate_always=1,
	  rotate_auto=2;

const counterclockwise=(1<<2);
const scale_height    =(1<<3);
const scale_width     =(1<<4);

$photo_option = new d_editor_option("photo_size_options", rotate_zero | scale_height | scale_width);

function NormalizePhoto($img)
{
global $photo_option;
$cfg=intval($photo_option->get());


$pw=imagesx($img);
$ph=imagesy($img);


$deg=0;
switch($cfg & rotate_method_mask)
{ case rotate_always: $deg=90; break;
  case rotate_auto:   if($pw>$ph) $deg=90; 
                      break;
}

if($deg)
{ 
  if(!($cfg  & counterclockwise)) $deg=-$deg;
  $img = imagerotate($img, $deg, 0);
  $pw=imagesx($img);
  $ph=imagesy($img);
}


$h=PhotoHeight; $w=PhotoWidth; //required values

//  if(!$pw || !$ph || $h<=0 || $w<=0) return;
if($ph<$h && $pw<$w) return $img; //no scale

if(($cfg & scale_height) && ($cfg & scale_width))
{
 if($ph*$w > $h*$pw) $w= intdiv($h * $pw , $ph);  
                else $h= intdiv($w * $ph , $pw);
}
else if($cfg & scale_height)
{ if($ph>$h) $w = intdiv($h * $pw , $ph);
       else {$h=$ph; $w=$pw; }
}
else if($cfg & scale_width)
{ if($pw>$w) $h= intdiv($w * $ph , $pw);
     else {$h=$ph; $w=$pw;}
}
else {$h=$ph; $w=$pw;}


$left=0; $top=0; $right=$w; $bottom=$h;
if($w>PhotoWidth)
{ $d=intdiv(($w-PhotoWidth),2);
  $left-=$d;
  $right-=$d;
  $w=PhotoWidth;
}
if($h>PhotoHeight)
{ $d=intdiv(($h-PhotoHeight),2);
  $top-=$d;
  $bottom-=$d;
  $h=PhotoHeight;
}


$res=imagecreatetruecolor($w, $h);
imagecopyresampled($res, $img, $left, $top, 0,0, $right-$left, $bottom-$top, $pw, $ph);
return $res;
}//NormalizePhoto


if($_SERVER['REQUEST_METHOD']==='POST' && ($_GET['action'] ?? null)=='preview')
{
 if($info=$_FILES['PHOTO'])
 {
    if($info['tmp_name'])  
	{	header('Content-Type: image/jpeg'); 
    	imagejpeg(NormalizePhoto(imagecreatefromjpeg($info['tmp_name'])));
    }		
    else  throw new Exception("   $info[name]");		 
 }
}


