<?php
include_once "elacset.php"; 
include_once "options.php"; 

assert_right(RT_FUNCTIONS, RI_SYSTEM);

new class extends TDataset
{
 public $photo_id=[]; //keys - ids
 public $opt;
 
 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'ID'; 
   	  public $names= ['update' => 'NEWID'];
      public $caption = '';
 	  public $data= true;
    },
    new class extends StringField
    { public $name = 'PROP_NAME';
      public $caption = ' ';  
  	  public $size=64;	  
    },	
    new class extends BoolField
    { public $name = 'PHOTO_ID'; 
      public $caption = '';
	  public $title = '   ';
    }	
  ];   
 
  $this->select_sql ='select * from USER_PROP_TYPES order by id';   
  $this->refresh_sql='select * from USER_PROP_TYPES where id=:id';
  $this->delete_sql ='delete from USER_PROP_TYPES where  id = :id';
  $this->update_sql ='update USER_PROP_TYPES set id=:newid, prop_name=:prop_name where id=:id';
  $this->insert_sql ='insert into USER_PROP_TYPES (id, prop_name) values(:id, :prop_name)'; 
  
  
  $this->opt=new d_option("photo_id/fields");
  $this->photo_id=array_flip(unpack('l*', $this->opt->get_blob() ?? ''));  
 }
 
function fetched(&$row) 
{ $row['PHOTO_ID']=isset($this->photo_id[$row['ID']]) ? 1 : 0; }
 
function update_photo_id()
{ 
  $this->opt->set_blob(pack('l*', ...array_keys($this->photo_id)));
}

function before_delete($params)
{
 unset($this->photo_id[$params['ID']]);
 $this->update_photo_id();
}

function before_insert($params)
{
 if(isset($params['PHOTO_ID'])) $this->photo_id[$params['ID']]=true;
 $this->update_photo_id();
}

function before_update($params)
{
 unset($this->photo_id[$params['ID']]);
 if(isset($params['PHOTO_ID'])) $this->photo_id[$params['NEWID']]=true;
 $this->update_photo_id();
}
 
 
protected $error_map = ['USER_PROP_TYPES_PK' => '   '];  
 
 
 }; //TDataset