<?php
include_once('login.php');
include_once('formdraw.php');
include_once('devconst.php');
include_once('dev_ip.php');

assert_right(RT_FUNCTIONS, RI_HARDWARE);


if(isset($_GET['reader']))
 $row = $db->prepare_execute('select * from D_DEVICES where reader=:reader', $_GET)->fetch(PDO::FETCH_ASSOC);
else 
 $row= ["COMPUTER" => $_GET['computer'] ?? null,
        "ADR" => str_to_dev_addr($_GET['adr'] ?? '192.168.0.0'),
		"SCHIT" => $_GET['schit'] ?? null,
        "READER_TYPE"=>3, 
        "R1_01"=>3, "R1_2"=>1, "R1_34"=>0, "R1_5"=>1, "R1_6"=>0, "R1_7"=>0, "R2_01"=>3, "R2_2"=>1, "R2_34"=>0,
        "R2_5"=>0, "R2_6"=>1, "R1_OPENTIME"=>5, "R2_OPENTIME"=>5, "R1_MAXTIME"=>15, "R2_MAXTIME"=>15, "NEED_SOUND"=>0,
        "WARN_RELE"=>5, "EXIT_WITH_OK"=>5, "TEST_REPEAT_ENTER"=>0, "WRITE_PHOTOID_EVENT"=>0];  
 
if(isset($_GET['rt']))  $row["READER_TYPE"]=intval($_GET['rt']);
 
extract($row);

if($SCHIT!=0)
 if($row=$db->query("SELECT R1_5,READER_TYPE FROM D_DEVICES where ADR=$ADR and COMPUTER=$COMPUTER and SCHIT=0")->fetch(PDO::FETCH_ASSOC))
   extract($row);

$GATE=$READER_TYPE==2; 
if($GATE) $R1_5=0; 
 
if($READER_TYPE==3)
{  
 $row = $db->query("select * from D5_DEVICES where ADR=$ADR AND COMPUTER=$COMPUTER")->fetch(PDO::FETCH_ASSOC); 
 $init_timers=!$row;
 if(!$row) 
   $row=['MODE' => 1, 'UART_SPEED1' => 0, 'UART_SPEED2' => 0, 'LPT_TYPE' => 0];	 
 
 if(isset($_GET['mode']))  
 { $row["MODE"]=intval($_GET['mode']);
   $init_timers=true;
 }
 
 if($init_timers)
 { 
   for($i=0; $i<TIMER_COUNT; $i++)  
      $row["TIMER$i"]=($el05def_timers[$row['MODE']][$i] ?? 0) * 10;  
   foreach(get_def_enters($row['MODE']) as $i=>$v) 
      $row['ENTER'.($i+1)]=$v;
 }
 

 for($i=0; $i<TIMER_COUNT; $i++)  $row["TIMER$i"]/=10;  
 extract($row, EXTR_PREFIX_ALL, 'DEV'); 
 
 $GATE=in_array($DEV_MODE, [5,6,7]); 

 $SIDE=el05calcside($DEV_MODE, $SCHIT);
    
 
 $row = $db->query("select * from D5_SIDES where ADR=$ADR and COMPUTER=$COMPUTER and SIDE=$SIDE")->fetch(PDO::FETCH_ASSOC);
 if(!$row) $row=['MODE'=>0, 'LOCK_RELE'=>0, 'UNBLOCKED_DOOR_INFO'=>0, 'TRIGGER_MODE'=>0, 'EM_LOCK' => $GATE ? 1 : 2];

 extract($row, EXTR_PREFIX_ALL, 'SIDE'); 
 
 if(isset($READER))
      $row = $db->query("select * from D5_READERS where reader=$READER")->fetch(PDO::FETCH_ASSOC);
 else $row = false; 
 if(!$row) $row=['TYPE'=>0, 'PHYS_ADDR'=>$SCHIT, 'PARAM'=>0, 'ID_MODE'=>0, 'LOCAL_APB'=>0, 'WARN_SOUND'=>0, 'OPEN_SOUND'=>0, 'ALGO'=>0];
 $row['PROPABILITY'] = $row['PARAM']     & 0xff;
 $row['THRESHOLD']   =($row['PARAM']>>8) & 0xffff;  
 extract($row, EXTR_PREFIX_ALL, 'RD');   
}  


function draw_select2($name, $items, $onchange)		   
{ draw_select($name, $items, "onchange=\"$onchange\""); }


$INTADR=$ADR;
$ADR=dev_addr_str($ADR); 
?>

<form id=readform autocomplete=off
      onreset="table_show_form(this.table_instance)"
      >

<input type=hidden <? draw_value('READER') ?>>

<style>
.groupbox
{border: 1px solid gray;
 margin: 0 2px 5px 2px; }

.groupbox>label
{display: block;}

.groupcaption
{ text-align: center; 
  font-weight: bold;
  background: silver;
}

#Glob input[type=number] 
{ width: 8ch;
  text-align: right;
}

#readform
{ background:  var(--tables-background);
  border: 1px solid black;
}

<? foreach($models as $rt=>$name)    echo "#Glob[data-rt='$rt'] [data-rt]:not([data-rt~='$rt']) { display: none; }\r\n";
   foreach($el05modes as $m=>$name)  echo "#Glob[data-mode='$m'] [data-mode]:not([data-mode~='$m']) { display: none; }\r\n";
   if($SCHIT!=0 && $R1_5==0)         echo "#GroupLook  { display: none; }\r\n";
?>

</style>

<script>
function on_rt_mode_change()
{ var q={};  
  q.rt=readform.READER_TYPE.value;

  if(readform.DEV_MODE)  
    q.mode=readform.DEV_MODE.value;  
  
  if(readers.table_state==ts_insert)
  { q.computer=readers.table_params.computer;
    q.adr=readform.ADR.value;
	q.schit=readform.SCHIT.value;
  }	 	  
  else  //ts_edit
    q.reader=readform.READER.value;	  
  
  table_load_form(readers, q);
}

function on_new_reader_change()
{ var q={};  
  q.computer=readers.table_params.computer;
  q.adr  =readform.ADR.value;
  q.schit=readform.SCHIT.value; 
  if(q.adr!='' && q.schit!='')
    table_load_form(readers, q);
}
</script>


<!--=============================================================================-->	
<div id=Glob data-rt="<?   echo $READER_TYPE?>" 
     		 data-mode="<? echo $DEV_MODE ?? '' ?>"
			 data-schit="<?echo $SCHIT ?>"
			 data-side="<? echo $SIDE ?? '' ?>" 
			 data-type="<? echo $RD_TYPE ?? '' ?>"
			 >
<div class=groupbox>
<div class=groupcaption> </div>
<table>
<tr><td> </td><td><input <? draw_value('ADR') ?> table_insertfocus required maxlength=15 size=15></td></tr>
<tr><td> </td><td><input <? draw_value('SCHIT'); 
                                            if(!isset($READER)) echo ' onchange="on_new_reader_change()"';										 
										 ?> required maxlength=1 size=1></td></tr>
<tr><td> </td><td><input <? draw_value('READ_NAME') ?> required maxlength=64 size=30></td></tr> 
</table>

</div>
			 
			 
<!--=============================================================================-->	
<div id=Glob5 class=groupbox>
<style>
#Glob:not([data-schit="0"]) #Glob5 {visibility: hidden; }
</style>
<div class=groupcaption> </div>

<table>
<tr><td> </td><td><? draw_select2('READER_TYPE', $models, "on_rt_mode_change()") ?></td></tr>
<tr data-rt='3'>
    <td> </td><td><? if($READER_TYPE>=3) draw_select2('DEV_MODE', $el05modes, "on_rt_mode_change()"); ?></td></tr>
</table>

<div id=Glob1 class=groupbox data-rt='0'>
<?  draw_radios('R1_6', [0 => '  818 ', 
                         1 => '  3275 ']); ?>
</div>
<div id=Glob2 class=groupbox data-rt='0'>
<?  draw_radios('R1_7', [0 => '   382 ', 
                        1 => '   1918 ']); ?>
</div>
<div id=Glob3 class=groupbox data-rt='0 1'>
<?  draw_radios('R1_5', [0 => ' 0 -   ,  1 -   ', 
                        1 => '   ( )']); ?>
</div>
<label data-rt='0'><? draw_check('NEED_SOUND'); ?> </label> 
<label data-rt='1'><? draw_check('R1_7'); ?>     </label> 
<label id=APB data-rt='1 2'><? draw_check('TEST_REPEAT_ENTER'); ?>  <? echo $READER_TYPE==2 ? "" : ""?></label>  

</div> <!-- Glob5 -->


<!--=============================================================================-->	
<div id=GroupR1 class=groupbox data-rt='0 1 2'>
<div class=groupcaption> </div>
<div class=groupbox style="column-count: 2"> 
 <label><? draw_check('R2_5'); ?> </label> 
 <label data-rt='1 2'><? draw_check('R1_6'); ?> </label>  
 <label><? draw_check('WRITE_PHOTOID_EVENT'); ?>   </label>  
 <label>   <input style="width: 7ch; float: right;" type=number min=0 max=255 <? draw_value('PERS_CODE_SERIA') ?>></label> 
</div> 
 <div class=groupbox style="column-count: 2"> 
                      <? draw_radios('R1_01',  [ 2 => '',
                                                1 => '',
                                                0 => ' + ',
                                                3 => '  ']); ?> </div>
</div> <!-- GroupR1 --> 


<!--=============================================================================-->	
<div id=GroupLook class=groupbox data-rt='0 1 2'>
<div class=groupcaption><? echo $GATE ? " " : " "?> </div>

 <div class=groupbox> <? draw_radios('R1_2', [ 0 =>  ($GATE ? '  ' : '  '), 
                                              1 => '  ']); ?> </div>
														   
 <div class=groupbox data-rt='0 1'><? $lm=[' ', ' ', ' '];
                                      if($READER_TYPE>0) $lm[]=' '; 
                                      draw_radios('R1_34', $lm); ?> </div>
<table>
<tr><td><? echo $GATE ? "- /" : "  "?></td>
    <td><input type=number min=0 max=255 required <? draw_value('R1_OPENTIME') ?>></td></tr>
<tr><td> <? echo $GATE ? "-   " : "  "?></td>
    <td><input type=number min=0 max=255 required <? draw_value('R1_MAXTIME') ?>></td></tr>
<tr data-rt='1 2'><td> <? echo $GATE ? "  ''" : " " ?></td>
    <td><input type=number min=0 max=255 <? draw_value('WARN_RELE') ?>></td></tr>
<tr data-rt='1 2'><td><? echo $GATE ? "  ''" : "   " ?></td>
    <td><input type=number min=0 max=255 <? draw_value('EXIT_WITH_OK') ?>></td></tr>
</table>																		 
</div> <!-- GroupLook --> 

<? if($READER_TYPE<3) return; ?>

<!--=============================================================================-->	
<div id=Reader class=groupbox>
<div class=groupcaption>  <? echo $SCHIT ?></div>
<table>
<tr class=anymode><td> </td>
    <td><? draw_select2('RD_TYPE', $el05read, "Glob.dataset.type=this.value")	?></td></tr>
<tr><td>. </td><td><input type=number min=0 max=255 required <? draw_value('RD_PHYS_ADDR') ?>></td></tr>
<tr id=RD_PARAM><td></td>  <td><input type=number required <? draw_value('RD_PARAM') ?>></td></tr>
<tr class=alcoparam><td></td><td><input type=number min=0 max=255 required <? draw_value('RD_PROPABILITY') ?>></td></tr>
<tr class=alcoparam><td></td><td><input type=number required min=0 <? draw_value('RD_THRESHOLD') ?>></td></tr>
<tr><td> </td><td><? draw_select('RD_ID_MODE', ['','','  ','  ']) ?></td></tr>
<tr><td> APB</td><td><? draw_select('RD_LOCAL_APB', $local_apb) ?></td></tr>
<tr><td> </td><td><? draw_select('RD_ALGO', ['', ' ']) ?></td></tr>
</table>
<label><? draw_check('RD_WARN_SOUND') ?>   </label>
<label><? draw_check('RD_OPEN_SOUND'); echo $GATE ? '      ' :
                                                    '    ';?></label>
<label><? draw_check('WRITE_PHOTOID_EVENT') ?>   </label>

				   
<style>
#Glob[data-mode="9"] #RD_PARAM~tr,
#Glob[data-mode="9"] #Reader>label {display: none; }

#Glob[data-type="9"]  #RD_PARAM,
#Glob[data-type="10"] #RD_PARAM {display: none; }

#Glob:not([data-type="9"]):not([data-type="10"]) .alcoparam {display: none; }
</style>

</div>
<!--=============================================================================-->	


<div id=GroupSide class=groupbox>
<div class=groupcaption><? echo el05side_name($DEV_MODE, $SIDE)  ?></div>
<input type=hidden <? draw_value('SIDE') ?>>
<table>
<tr><td> </td><td><? draw_select('SIDE_MODE', [' ', '', '']); ?></td></tr>

<tr id=LabelLOCK_RELE><td>
<? echo $GATE ? " " : 
                "  "; ?> </td>
<td> 				
<? draw_select('SIDE_LOCK_RELE', $GATE ?  [' ', ' ']
  									   :  [' ', '  ', '  ']  ); ?> </td>
</tr>
</table>

<style> #Glob[data-mode='3']  #LabelLOCK_RELE {display: none;}	</style>														

<label data-mode="1 2 5 6"><? draw_check('SIDE_TRIGGER_MODE') ?> </label>
<label data-mode="1 2 3 4 5 6 7">
<? draw_check('SIDE_UNBLOCKED_DOOR_INFO'); 
   echo $GATE ? "      " 
              : "     "; 
?>
</label>
<label data-mode="1 2 4"><? draw_check('SIDE_EM_LOCK') ?> </label>
</div>



<!--=============================================================================-->	
<div id=Timers class=groupbox>
<div class=groupcaption></div>
<table>
<?php
$rlist = $db->query("select distinct r.type from D_DEVICES d, D5_READERS r where d.reader=r.reader and d.ADR=$INTADR AND d.COMPUTER=$COMPUTER")->fetchAll(PDO::FETCH_COLUMN); 

foreach(el05timer_names($DEV_MODE, $rlist) as $i=>$name) { ?>
 <tr><td><?echo $name?></td>
 <td><input data-id=<? echo $i ?> type=number required step='0.1' min=0 max=9999 <? draw_value("DEV_TIMER$i") ?>></td></tr>
<? } ?>
</table>
<input type=button value=" "  onclick="set_def_timers()">
 
<script>
function set_def_timers()
{
 const def_timers=<? echo json_encode($el05def_timers[$DEV_MODE]); ?>;

 for(let inp of Timers.querySelectorAll(':scope input[data-id]'))
  inp.value=def_timers[inp.dataset.id] || 0;

 readform.dispatchEvent(new Event('input')); 
}
</script>
 
<style>
#Timers td:first-child {padding-right: 1ch;}
</style>
</div>

<!--=============================================================================-->	
<div id=Enters class=groupbox>
<div class=groupcaption>  </div>
<table>
<?
for($i=0; $i<ENTER_COUNT/2; $i++)
{ echo "<tr><td>$enter_names[$i]</td><td>";
  draw_select('DEV_ENTER'.($i+1), $enter_modes); 
  echo "<td>",$enter_names[$i+ENTER_COUNT/2],"</td><td>";
  draw_select('DEV_ENTER'.($i+ENTER_COUNT/2+1), $enter_modes); 
  echo "</td></tr>";
}
?>
</table>
<input type=button value=" "
 onclick="<?foreach(get_def_enters($DEV_MODE) as $i=>$v) 
               echo "this.form['DEV_ENTER",$i+1,"'].value=$v;" ?>
         this.form.dispatchEvent(new Event('change'))">
<style>#Enters td:nth-child(3) { padding-left: 3ch; }</style>
</div>
<!--=============================================================================-->	
<div id=Ports class=groupbox>
<div class=groupcaption> /</div>
<table>
<tr><td> UART   1</td><td><? draw_select('DEV_UART_SPEED1', $speeds) ?></td></tr> 
<tr><td> UART   2</td><td><? draw_select('DEV_UART_SPEED2', $speeds) ?></td></tr>
<tr><td>    </td><td><?draw_select('DEV_LPT_TYPE', $lpt_types) ?></td></tr> 
</table>
<style>#Ports select {  width: 10ch; }</style>
</div>
<!--=============================================================================-->	
<div id=Program class=groupbox>
<div class=groupcaption> </div>
<table>
<tr><td> </td> 
<td>
<?
$vmprogs = [null => ''];
foreach($db->query('select id, name from d5_programs order by id') as $row)
 $vmprogs[$row[0]] = $row[1];

draw_select('DEV_PROGRAM', $vmprogs);
?>
</td></tr></table>
</div>
<!--=============================================================================-->	
</div> <!-- Glob -->



</form> <!-- readform -->