<?php
include_once "elacset.php"; 
include_once "WF3.php"; 
include_once 'cardcode.php';

assert_right(RT_FUNCTIONS, RI_GUEST_CARDS);

new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'CARD_NUM'; 
      public $caption = ' ';
 	  public $data= true;
    },
    new class extends CardCodeField
    { public $name = 'CARD_CODE';
      public $caption = ' ';  
  	  public $size=12;	  
    },	
    new class extends StringField
    { public $name = 'USERNAME';
      public $caption = ' ';  
	  public $readonly = true;
    }	
  ];   

  $sel = 'select c.*,o.user_ref,u.username from D_TMP_CARDS c 
          left join D_OWNERS o on c.card_code=o.card_code
          left join USERS u on o.user_ref=u.num';

  $this->select_sql = $sel.' order by c.card_num';     
  $this->refresh_sql= $sel.' where c.card_num=:card_num';
  $this->delete_sql = 'delete from D_TMP_CARDS where card_num = :card_num';
  $this->insert_sql = 'insert into D_TMP_CARDS (card_num, card_code)  values (:card_num, :card_code)'; 
 }
 
 function get_tr_classes($row)
 { if($row['USER_REF'])  return ['row-readonly'];  }  
 
 
 function before_delete($params)
 {
   if($this->prepare_execute('select requisition from D_TMP_CARDS where card_num=:card_num', $params)->fetchColumn())
    throw new Exception('        ');
 }  
 

 
protected $error_map = 
	['D_TMP_CARDS_UNIQ1' => '      ', 
	 'D_TMP_CARDS_PK'    => '    '];  
 

 
 
 }; //TDataset 