<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_SYSTEM);

new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'ID'; 
      public $caption = '';
 	  public $data= true;
	  public $names= ['update' => 'NEWID'];
	  
	  function get_default($action)
	  { return $this->dataset->db->query('select max(id) from D_REQ_DATA_TYPES')->fetchColumn()+1; }	  
    },
    new class extends StringField
    { public $name = 'NAME';
      public $caption = '';  
  	  public $size=64;	  
    },
	new class extends LookupField
	{ public $name = 'EDIT_MODE';
      public $caption = ' ';  	  
	  public $title = '    ';  	  
	  public $list = [ 0 => "",
                       1 => "  ",
					   2 => "  "];
	},
    new class extends BoolField
	{ public $name = 'REQUIRED';
      public $caption = '.';  	  
	  public $title = '     ';  	  
	},
    new class extends IntField
	{ public $name = 'REQ_TYPE';
      public $caption = ' ';  	  
	  public $title = '      (  )';  	  
	  public $required=false;
	},
    new class extends StringField
    { public $name = 'EDIT_MASK';
      public $caption = '';  
	  public $title = '       html- pattern';  	  
  	  public $size=64;	  
	  public $required=false;
    },
    new class extends IntField
	{ public $name = 'SCREEN_SIZE';
      public $caption = '';  	  
	  public $title = '     ';  	  
	  public $required=false;
	},
    new class extends StringField
    { public $name = 'COMBO_LIST';
      public $caption = ' ';  
	  public $title = '      "  "';  	  
	  public $required=false;
	  
	  function draw_edit_text($value, $row)   
	  { if(!is_null($value)) 
	      $this->draw_text(str_replace("\r\n", ",", $value), $row); 	  
	  }
	  
      function parse($v)
      { if($v=='') return null;
	          else return str_replace(",", "\r\n", $v);
	  }  
    }	 	
   ];   


  $this->select_sql = 'select * from D_REQ_DATA_TYPES order by id';     
  $this->refresh_sql= 'select * from D_REQ_DATA_TYPES where id=:id';
  $this->delete_sql = 'delete from d_req_data_types where id = :id';   
  
  $this->insert_sql = 'insert into D_REQ_DATA_TYPES (id,name,edit_mask,screen_size,edit_mode, required, req_type, combo_list)
                       values(:id, :name, :edit_mask, :screen_size, :edit_mode, :required, :req_type, :combo_list)'; 
					   
  $this->update_sql = '
  update D_REQ_DATA_TYPES set 
    id = :newid,
    name = :name,
    edit_mask = :edit_mask,
    screen_size = :screen_size,
    edit_mode = :edit_mode,
    required = :required,
    req_type = :req_type,
    combo_list = :combo_list
   where  id = :id';    
 }
 
 

 
protected $error_map = 
	['PRIMARY or UNIQUE KEY' => '   '];  

 
 
 }; //TDataset 