<?php
include_once "elacset.php"; 
include_once "colors.php"; 

assert_right(RT_FUNCTIONS, RI_SYSTEM);

new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'ID'; 
      public $caption = '';
 	  public $data= true;
	  public $names= ['update' => 'NEWID'];
	  
	  function get_default($action)
	  { return $this->dataset->db->query('select max(id) from D_REQ_TYPES')->fetchColumn()+1; }	  
    },
    new class extends StringField
    { public $name = 'NAME';
      public $caption = ' ';  
  	  public $size=64;	  
	  
      function get_styles($value, $row)  
	  { 
	    if(!is_null($row['COLOR'])) 
         	 return ["background: ".html_color($row['COLOR']),  'color: black']; 	  
	  }
	  
    },
    new class extends ColorField
    { public $name = 'COLOR'; 
      public $data= true;
      public $visible  = false; 
 	  public $required = false;
    }	
   ];   


  $this->select_sql = 'select * from D_REQ_TYPES order by id';     
  $this->refresh_sql= 'select * from D_REQ_TYPES where id=:id';
  $this->delete_sql = 'delete from D_REQ_TYPES where id=:id';
  $this->insert_sql = 'insert into D_REQ_TYPES(id,name,color) values(:id, :name, :color)'; 
  $this->update_sql = 'update D_REQ_TYPES set  id = :newid, name = :name,  color = :color   where id = :id'; 
 }
 

 
protected $error_map = 
	['PRIMARY or UNIQUE KEY' => '   '];  

 
 
 }; //TDataset 