<?php
include_once 'reports.php';
include_once "workflow.php";


$right_types=
[ RT_FUNCTIONS	=>"",
  RT_USERPROPS	=>" ",
  RT_GROUPS		=>"",
  RT_WEBREPORTS	=>"",
  RT_TZ        	=>"",
  RT_LEVELS		=>" ",
  RT_TIMEZONES	=>" ",
  RT_SMENA		=>"",
  RT_READERS	=>"",
  RT_PHOTOID_FIELDS=>" ",
  RT_OPERATORS	=>"",
  RT_RIGHTS		=>" ",
  RT_EVENT_FILTERS=>""
];  


$function_rights=
[          RI_SYSTEM     =>  "",
           RI_HARDWARE   =>  "",
           RI_CLEARBASE  =>  " ",
           RI_APB        =>  " ",
           RI_WORK_MODES =>  "  ",
           RI_ACCESSLEVELS=> " ",
           RI_TIMEZONES  =>  " ",
           RI_SMENA_GRAPHICS=>" ",
           RI_HOLIDAYS  =>   "",
           RI_USERS     =>   "",
           RI_GROUPS    =>   "",
           RI_MASS_UPDATE => " ",
           RI_REPORTS    =>  "",
           RI_EXPORTMODULE=> " ",
           RI_OPERATORS  =>  "",
           RI_EVENTSBASE =>  " ",
           RI_DIAG       =>  "",
           RI_PHOTOID    =>  "",
           RI_ALLOW_PASS =>  " ",
           RI_OPEN_DOOR  =>  " ",
           RI_CHANGEPASSWORD=>" ",
           RI_MONITORING =>  " ",
           RI_HELP       =>  ""
 ];

 
 
$user_rights=
[ RU_NAME => "",
  RU_GROUP => "",
  RU_TABNUMBER => " ",
  RU_CARD => "",
  RU_LEVEL => " ",
  RU_PERIOD => " ",
  RU_PRIM => "",
  RU_PHOTO => "",
  RU_COLOR => "",
  RU_PRINT => " ",
  RU_ADD_DELETE => "  "
];


function make_right_lookup($sql)
{ global $db;
  $l=[];
  foreach($db->query($sql) as [$id,$name])  
    $l[$id]=$name;
  return $l;	
}  
 


$get_right_list = //map type => func() which return map [$id=>name]
[
 RT_FUNCTIONS =>  function()  { return $GLOBALS['function_rights']; },
 
 RT_GROUPS => function() { return make_right_lookup('select NUM,GROUPNAME from groups order by GROUPNAME'); },
 
 RT_SMENA => function() { return make_right_lookup('select SMENA,NAME from D_SMENA order by NAME'); },
 
 RT_LEVELS => function() { return make_right_lookup('select A_LEVEL,A_NAME from D_ACCESS_LEVELS order by A_NAME'); },

 RT_TZ => function() { return make_right_lookup('select NUM,ZONENAME from TER_ZONES order by ZONENAME'); },

 RT_READERS => function() { return make_right_lookup('select READER,READ_NAME  from D_ABSTRACT_READERS order by READ_NAME'); },
 
 RT_PHOTOID_FIELDS => function() 
                     { return [ PHID_NOFIELDS => ' ',
					            RU_NAME => '',
								RU_GROUP => '',
								PHID_READER => ''] 
							  + make_right_lookup('select ID,PROP_NAME from USER_PROP_TYPES  order by ID');
					 },
 
 RT_OPERATORS => function() { return make_right_lookup('select EDITOR,EDITOR_NAME  from D_EDITOR_SETTINGS order by EDITOR_NAME'); },

 RT_USERPROPS => function() 
                 { return $GLOBALS['user_rights'] + make_right_lookup('select ID,PROP_NAME  from USER_PROP_TYPES  order by ID'); },

 RT_TIMEZONES => function() 
                 { return make_right_lookup('select ZONE,Z_NAME from D_TIMEZONES order by Z_NAME'); },
 
 RT_EVENT_FILTERS =>  function() 
                      { return make_right_lookup('select ID,NAME from D_FILTERS where EDITOR is null order by NAME'); }, 
 
 RT_RIGHTS => function() 
              { return  $GLOBALS['right_types'] + [RR_NEW_OPERATOR => "  "]; }, 
 
 RT_WEBREPORTS => function() 
              { $res=[];
			    foreach(load_reports() as $rpt)
				  $res[$rpt->id]=$rpt->name;
				return $res;
			  }
 
];



foreach($workflows as $w)
{ if(isset($w->right_types))
   $right_types+=$w->right_types;
   
  if(isset($w->function_rights))
   $function_rights+=$w->function_rights;

  if(isset($w->get_right_list))
   $get_right_list+=$w->get_right_list;
}  

