<?php
$editor_rights = []; //type => [rights]

function right_restricted($right_type)
{ global $editor_rights;
  return isset($editor_rights[$right_type]);
}

function has_right($right_type, $right_id)
{ global $editor_rights;
  return !isset($editor_rights[$right_type])
         ||
		 in_array(intval($right_id), $editor_rights[$right_type]);  
}

function has_func($func_id)
{ return has_right(RT_FUNCTIONS, $func_id); }

function assert_right($right_type, $right_id)
{ if(!has_right($right_type, $right_id)) throw new Exception(' '); }


function sql_where($prefix, $right_type)
{ global $editor_rights;
  $rl = $editor_rights[$right_type] ?? [];
  switch(count($rl))
  { case 0:  return '';
    case 1:  return $prefix."=".$rl[0];
	default: return $prefix." in (".implode(',',$rl).")";
  }
}

function gen_RI_style($ri_list)
{
 foreach($ri_list as $r)
  if(!has_right(RT_FUNCTIONS, constant($r)))
   echo " .$r { display: none; }\r\n";
  
}
 
function load_rights($q)
{ global $editor_rights;
  foreach($q as $row)
    $editor_rights[$row[0]][]=$row[1];
} 