<?php
include_once "elacset.php"; 
include_once "tz_stuff.php"; 

assert_right(RT_FUNCTIONS, RI_TIMEZONES);


new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends GenIntField
    { public $name  = 'PR_KEY'; 
 	  public $data = true;
	  public $generator = 'D_GEN_TZ_INTERVAL';
	  public $visible=false;
    },

    new class extends IntField
    { public $name  = 'SMENA'; 
	  public $visible=false;
    },	
    new class extends StringField
    { public $name  = 'LETTER'; 
      public $caption =  '';
	  public $size=1;
    },		
    new class extends HourField
    { public $name  = 'H_START';  
	  public $title = '  ';
	  
	  public $extra_caption = '';
  	  public $extra_colspan = 2;		
    },	
	
    new class extends MinuteField
    { public $name  = 'M_START';  
	  public $title = '  ';
    },	

    new class extends HourField
    { public $name  = 'H_END';  
	  public $title = '  ';
 	  public $max   = 24;

	  public $extra_caption = '';
  	  public $extra_colspan = 2;		
    },	

    new class extends MinuteField
    { public $name  = 'M_END';  
	  public $title = '  ';
    },	
	
	new class extends DBLookupField
	{ public $name  = 'ZONE';  
      public $caption =  ' ';
	  public $query = 'select zone,z_name from D_TIMEZONES where zone>2 order by z_name';
	  public $min = 3;
	}

	
  ];
  
  $this->select_sql = 'select * from D_SMENA_INTERVALS where smena=:smena order by letter,H_START';   
  $this->refresh_sql= 'select * from D_SMENA_INTERVALS where pr_key=:pr_key';
  $this->delete_sql = 'delete   from D_SMENA_INTERVALS where pr_key=:pr_key';
  $this->update_sql = 'update D_SMENA_INTERVALS set 
                        letter = :letter,
                        h_start = :h_start,
                        m_start = :m_start,
                        h_end = :h_end,
                        m_end = :m_end,
                        zone = :zone
                       where pr_key = :pr_key';	
	
  $this->insert_sql ='insert into D_SMENA_INTERVALS(pr_key, smena, letter, h_start,  m_start,  h_end,  m_end, zone)
                      values (:pr_key, :smena, :letter, :h_start, :m_start, :h_end, :m_end, :zone)';    
 }

 protected $error_map=['D_SMENA_INTERVALS_CHECK' => '   '];
 
}; 
 