//  (ts - "table_state")
const ts_disabled=0;
const ts_browse=1;
const ts_selected=2;
const ts_edit=3;
const ts_insert=4;

// 
const table_state_names=["ts_disabled", "ts_browse", "ts_selected", "ts_edit", "ts_insert"];

//  
if(!on_table_error)
 var on_table_error = alert;


function table_this_invoke_event(name, detail)
{ 
  var event=new CustomEvent(name, {cancelable: false, detail: detail });
  this.dispatchEvent(event);  
  if(event_attribute=this.getAttribute(name)) 
    eval(event_attribute);
}

function table_invoke_event(table, name, detail)
{ table_this_invoke_event.call(table, name, detail);
  if(table.table_form) table_this_invoke_event.call(table.table_form, name, detail);
}


function table_set_class(table, st)
{
  table.classList.remove(...table_state_names);
  table.classList.add(table_state_names[st]);
}

function table_set_state(table, st)
{
  if(es=table.getAttribute('table_emit_state'))
    for(let n of document.querySelectorAll(es))
	{
      if(table.table_state)
	    n.classList.remove(table.id+'_'+table_state_names[table.table_state]);
	  n.classList.add(table.id+'_'+table_state_names[st]);
	}  
	
  if(table.table_form) table_set_class(table.table_form, st); //   

  if(table.table_state==st) return;
  if(table.table_state==ts_selected && st!=ts_edit)
  {  table_invoke_event(table, "on_table_deselect");
     table_close_form(table);
  }
  table.table_state=st;
  table_invoke_event(table, "on_table_state", { state: st});    
  table_set_class(table,st);
}

function table_remove_row_class(table)
{
 for(let cl of [...table.classList.values()])
  if(cl.startsWith('row-'))
   table.classList.remove(cl);
}

function table_deselect(table)
{
  table_remove_row_class(table);
  if(tr=table.querySelector(':scope tr.selected'))
  { tr.classList.remove('selected'); 
	table_set_state(table, ts_browse);
  }
}


function table_select(table, tr)
{ 
   for(let n of table.querySelectorAll(':scope tr.selected'))  
      n.classList.remove('selected');
   tr.classList.add('selected');
   table_set_state(table, ts_selected);   
   table_remove_row_class(table);
   for(let cl of tr.classList)
     if(cl.startsWith('row-'))
  	  table.classList.add(cl);
   
   table_invoke_event(table, "on_table_select", { row: tr});
}

function table_append_dataset(formdata, tr)
{
  //let ds=Object.assign({}, tr.dataset);
  if(tr)
   for(let n in tr.dataset)
    formdata.set(n, tr.dataset[n]);
}

function table_row_dataset(tr)
{ 
  let fd=new FormData;
  table_append_dataset(fd, tr);
  return fd;
}

function table_set_form(table, tr) 
{
  if(!table.table_form)
  {  table.table_form=document.createElement("form"); //lform;
     table.table_form.id="tf" + Math.random().toString(36).substr(2, 9);
	 table.table_form.setAttribute('autocomplete','off');  
	 table.table_form.classList.add('inplace');	
	 table.after(table.table_form); //appendChild(table.table_form);
  }

  for(let n of tr.querySelectorAll(':scope *[name]'))
    n.setAttribute('form',table.table_form.id);  
	
  table.table_form.hidden=false;	
}

//return row-editor
function table_edit(table, tr)
{
  if(!tr) tr=table.querySelector(':scope tr.selected');
  
  if(etr=table_row_load(table, 'edit', table_row_dataset(tr)))
  {  etr.classList.add('inplace', 'editing');
     tr.classList.add('edited');
     table_set_form(table, etr);
     tr.parentNode.insertBefore(etr, tr);
	 table_set_state(table, ts_edit);
	 return etr;
  }  
}

//return inplace or selected row 
function table_current_row(table)
{
 switch(table.table_state)
 { case ts_edit:
   case ts_insert:   return table.querySelector(':scope tr.inplace');
   case ts_selected: return table.querySelector(':scope tr.selected');
   default: return null;
 }
}

function table_current_dataset(table)
{ return table_row_dataset(table_current_row(table)); }

//return inplace row (calling table_edit or table_insert if nessesary)
function table_make_editable(table)
{
 switch(table.table_state)
 { case ts_edit:
   case ts_insert:   return table.querySelector(':scope tr.inplace');
   case ts_selected: return table_edit(table);
   case ts_browse:   return table_insert(table);
   default: return null;
 }
}

function table_cancel(table)
{
  table_invoke_event(table, "on_table_before_cancel");  
  
  if(tr=table.querySelector(':scope tr.inserting'))
    tr.remove(); 
  else
  if(tr=table.querySelector(':scope tr.editing'))
  {
    tr.remove();
	if(tr=table.querySelector(':scope tr.edited'))
	  tr.classList.remove('edited');	
	  
  }  

  if(table.querySelector(':scope tr.selected'))
  {
    if(!table.table_form.hidden) table.table_form.reset(); 
	table_set_state(table, ts_selected);     
  }		
  else  
  {  
    table.table_form.innerHTML ='';
    table.table_form.hidden=true;    
    table_set_state(table, ts_browse);	       
  }
   
  
  table_invoke_event(table, "on_table_after_cancel");  
}

function table_post_insert(table)
{  let tr=table.querySelector(':scope .inserting'); 
   table_invoke_event(table, "on_table_before_post", { row: tr, action: 'insert'});  
   if(!table.table_form.reportValidity()) return;   
   let fd=new FormData(table.table_form);
   table_append_dataset(fd, tr);
   
   let res=table_action(table, 'insert', fd);   
   if(res.children[0].tagName=="COLGROUP") //full refresh
     table_replace_all(table,res);    
   else
   { let newtr = res.children[0];
 	 if(tr) tr.replaceWith(newtr);
	   else table.tBodies[0].appendChild(newtr);
     table_invoke_event(table, "on_table_after_post", { row: newtr, action: 'insert'});  
	 newtr.scrollIntoView();
	 table_select(table, newtr);
   }	
}

function table_post_edit(table)
{
   let tr=table.querySelector(':scope .editing'); //can be null if form edit
   table_invoke_event(table, "on_table_before_post", { row: tr, action: 'update'});  
   if(!table.table_form.reportValidity()) return;
   let fd=new FormData(table.table_form);
   table_append_dataset(fd, tr);
   
   let res=table_action(table, 'update', fd);   
   if(res.children[0].tagName=="COLGROUP") //full refresh
     table_replace_all(table,res);    
   else
   { if(tr) tr.remove();
     let newtr = res.children[0];
     if(seltr=table.querySelector(':scope tr.selected'))
          seltr.replaceWith(newtr);
	 
	 
     table_invoke_event(table, "on_table_after_post", { row: newtr, action: 'update'});  
     table_select(table, newtr);     
   }	
}


function table_post(table)
{ //reset custom validity
  for(let n of table.table_form.querySelectorAll(':scope :invalid'))
    n.setCustomValidity('');

  switch(table.table_state)
  { case ts_insert: table_post_insert(table); break;
    case ts_edit:   table_post_edit(table);   break;
  } 
}

//return inplace row
function table_insert(table)
{
  table_deselect(table);
  table_invoke_event(table, "on_table_before_new");  
  
  if(table.getAttribute('table_form'))
  {  table_insert_form(table, table_make_action_params(table, 'new'));
     table_invoke_event(table, "on_table_after_new");     
  }
  else  
  if(tr=table_row_load(table, 'new'))
  {  
   tr.classList.add('inplace', 'inserting');
   table_set_form(table, tr); 
   table.tBodies[0].appendChild(tr);
   table_set_state(table, ts_insert);
   
   if((af=table.getAttribute('table_autofocus')) &&
      (f=tr.querySelector(":scope input[name='"+af+"' i]")))
        f.focus(); 
   else 
   if(f=tr.querySelector(':scope input[name][value=""]')) f.focus();   
   else   
   if(f=tr.querySelector(':scope input')) f.focus();   
   table_invoke_event(table, "on_table_after_new", { row: tr}); 
   return tr; 
  } 
}

function table_delete(table)
{
  if(tr=table.querySelector(':scope .selected'))
   {   
     table_invoke_event(table, "on_table_before_delete", { row: tr}); 
	 table_action(table, 'delete', table_row_dataset(tr));
	 tr.remove();   
     table_set_state(table, ts_browse);
	 table_invoke_event(table, "on_table_after_delete", { row: tr}); 
   }    
}

function table_close(table)
{ 
  table_set_state(table, ts_disabled);
  table.querySelectorAll(':scope>tbody').forEach( function(t)  { t.remove(); });
}

function table_reopen(table, action='select')
{ table_replace_all(table, table_action(table, action));}

function table_next(table)
{
 if(table.table_state==ts_selected)
  if(tr=table.querySelector(':scope tr.selected').nextElementSibling)
  { table_select(table, tr); 
  	if(tr.scrollIntoViewIfNeeded)
          tr.scrollIntoViewIfNeeded(false);
	else  tr.scrollIntoView({block: "center"});	
  }	
}

function table_prev(table)
{
 if(table.table_state==ts_selected)
  if(tr=table.querySelector(':scope tr.selected').previousElementSibling)
  { table_select(table, tr); 
    tr.scrollIntoView({block: "center"});
  }	
}


function table_replace_all(table, content)
{
  for(let n of table.querySelectorAll(':scope>tbody, :scope>thead, :scope>colgroup'))
     n.remove();
  table.appendChild(content);   
  table_after_open(table);	 
}


function table_make_action_params(table, action, fd) //return fd or new FormData if needed
{ //specific action params
  if(table.table_action_params_instance[action])
    for(let pn in table.table_action_params_instance[action])
    { if(!fd) fd=new FormData;
      if(!fd.has(pn))
	    fd.set(pn, table.table_action_params_instance[action][pn]);
    }

  //general table params
  for(let pn in table.table_params)
  { if(!fd) fd=new FormData;
    if(!fd.has(pn))
	  fd.set(pn, table.table_params[pn]);
  }
  return fd;
}

function table_action(table, action, fd) //return DocumentFragment
{
  fd=table_make_action_params(table, action, fd);
  
  var xhr = new XMLHttpRequest();
  xhr.open('POST', (table.getAttribute('table_data') || table.id+'_data.php')+'?action='+action, false);
  if(fd) xhr.send(fd);
    else xhr.send();
  //console.log(xhr.status, xhr.responseText);
  if(xhr.status==200) 
  { var templ = document.createElement("template");
    templ.innerHTML = xhr.responseText;  
    return templ.content;
  }
  else  
 { //alert(": "+xhr.responseText);
   on_table_error(xhr.responseText);
   throw xhr.responseText; 
 }
}

function table_action_blob(table, action, fd, on_load) //call on_load(blob)
{
  fd=table_make_action_params(table, action, fd);
  
  var xhr = new XMLHttpRequest();
  xhr.open('POST', table.getAttribute('table_data')+'?action='+action);
  xhr.responseType = 'blob';
  if(fd) xhr.send(fd);
    else xhr.send();
	
  xhr.onload = function(e) 
  {	if(xhr.status==200) on_load(xhr.response);
                  else  {  xhr.responseType='';
				           on_table_error(xhr.responseText);
				        } 
  }
}


//using current row dataset
function table_row_action(table, action)
{ var tr=table.querySelector(':scope tr.selected');
  return table_action(table, action, table_row_dataset(tr));
}


function table_row_load(table, action, fd)
{
  if(content=table_action(table, action, fd))
    if(content.childElementCount)
      return content.children[0];
}

//load and append row and select it
function table_row_load_append(table, action, fd)
{
  tr=table_row_load(table, action, fd);
  table.querySelector(':scope>tbody').appendChild(tr);	
  tr.scrollIntoView();
  table_select(table, tr);   
}  

//call action+fd on current row and replace it
function table_row_replace(table, action, fd)
{  
  if(!fd) fd=table_current_dataset(table);
  var newtr=table_action(table, action, fd).children[0];
  tr.replaceWith(newtr);
  table_select(table, newtr);
  return newtr;
}


function table_row_count(table)
{ return table.tBodies[0].children.length; }


function table_close_form(table)
{
  if(table.tagName!='TABLE') table=table.table_instance;
  if(!table)  return;
  if(!table.table_form) return;
  table.table_form.innerHTML ='';
  table.table_form.hidden=true; 
  
  if(table.table_state==ts_insert || table.table_state==ts_edit)
    table_cancel(table)  
}

function table_load_form(table, params) //params is Object of FormData 
{
  let form=document.getElementById(table.getAttribute('table_form'));  
  let uri=form.id+'.php';  
  if(params) uri+='?'+(new URLSearchParams(params)).toString();
  var xhr = new XMLHttpRequest();
  xhr.open('GET', uri, false);  
  xhr.send();  
  if(xhr.status!=200) 
  { on_table_error(xhr.responseText);
    throw xhr.responseText; 
  }   
  form=load_form(form, xhr); 
  form.addEventListener("input",  table_form_on_input);   
  table.table_form=form;
  form.table_instance=table;
  table_set_class(form, table.table_state);  
  form.focus();
  
  if(table.table_state==ts_insert)
   if(af=form.querySelector(':scope [table_insertfocus]'))
    af.focus();  
  
  return form;
}

function table_show_form(table) //show the form from table_form attribute for current row
{
  if(table.tagName=='FORM') table=table.table_instance;
  table_load_form(table, table.querySelector(':scope tr.selected').dataset);  
}

function table_insert_form(table, params)
{ table_deselect(table);
  table_set_state(table, ts_insert);
  table_load_form(table, params);      
}

function table_form_on_input(event)
{ if(event.target.name && event.target.form==this)
   if(this.classList.contains('ts_selected'))
   	table_set_state(this.table_instance, ts_edit);      
}

function table_form_input_change(input)
{ input.dispatchEvent(new Event('input', { bubbles: true}));
}


function table_body_click(ev)		 
{
 tbody=this;
 let table=tbody.parentElement;
            
 var tr=ev.target;
 while(tr && tr.parentElement!=tbody) tr=tr.parentElement; //get clicked row
 
 if(!tr.classList.contains('inplace')) 
   ev.preventDefault(); //     
   
 if(table.table_state==ts_insert || table.table_state==ts_edit) return; //        
  
 if(tr.classList.contains('selected'))
 {  //edit row
    let td=ev.target;
	while(td && td.parentElement!=tr) td=td.parentElement; //get clicked cell
	
	let idx = 0; //click cell index
    while(td=td.previousElementSibling) idx++;

    if(tr.classList.contains('row-readonly') ||  table.classList.contains('readonly') || table.classList.contains('noinplace'))
  	  table_invoke_event(table, "on_table_dblselect", { row: tr});    	
	else
	{	
      tr=table_edit(table, tr); //editor
	
      for(td=tr.firstElementChild; idx && td; idx--) td=td.nextElementSibling;
	
      if(inp=td.querySelector(':scope input:not([type=hidden])'))
      { inp.focus();	
        inp.select();
      } 

      if(ev.target.tagName=='INPUT' && ev.target.type=='checkbox')	
        if(inp=td.querySelector(':scope input[type=checkbox]'))
          inp.checked=!inp.checked;	 
    }		  
 } 
 else  table_select(table,tr); 
}

//title click event handler
function table_sortby(ev)
{  
  var th=ev.target.closest('th');
  var table=th.closest('table.table');
  var tp = table.table_action_params.select; 
  
  tp.sort=th.classList.item(0);
  if(th.classList.contains("asc"))  
        tp.desc='';
  else 	delete tp.desc;
  table_reopen(table);
}


function on_table_reverse_scroll(table)
{ if(table.parentElement.scrollTop!=0) return;  

  var body=table.tBodies[0];
  var tr0=body.firstElementChild;
  if(!tr0 || body.dataset.table_eof) return;
  
  var data=table_action(table, 'scroll', table_row_dataset(tr0)); //data: DocumentFragment
  if(data.childElementCount)
       { body.prepend(data);
	     tr0.scrollIntoView();		
	   }	 
  else body.dataset.table_eof=1;  
}

function on_table_direct_scroll(table)
{ 
  if(table.parentElement.scrollHeight - table.parentElement.scrollTop - table.parentElement.clientHeight>5) return;

  var body=table.tBodies[0];
  var tr0=body.lastElementChild;
  if(!tr0 || body.dataset.table_eof) return;
  
  var data=table_action(table, 'scroll', table_row_dataset(tr0)); //data: DocumentFragment
  if(data.childElementCount)
       body.appendChild(data);
  else body.dataset.table_eof=1;  
}


function table_after_open(table)
{
  if(tbody=table.querySelector(":scope>tbody"))
  {  tbody.addEventListener("click", table_body_click);     
	 
	 if(tr=tbody.querySelector(":scope>tr.selected"))
	      table_select(table,tr);	 
	 else table_set_state(table, ts_browse);  	 
  }	 
  else  table_set_state(table, ts_disabled);  
  
  if(table.classList.contains('autosort'))
   if(thead=table.querySelector(":scope>thead"))	
    thead.addEventListener("click", table_sortby);
	
  if(table.classList.contains('reverse'))	
    table.parentElement.scrollTo( { top: table.parentElement.scrollHeight, behavior: "instant" } );
	
  table_invoke_event(table, "on_table_after_open", { table: table});    
}

function table_init(table)
{
  if(tf=table.getAttribute('table_form'))
  {  table.table_form = document.getElementById(tf);
     table.table_form.addEventListener("input", 
     function()
	    { if(table.table_state==ts_selected)
		  { table_edit(table);
		  }
		});
   }
	
  if(tp=table.getAttribute('table_params'))
       table.table_params=eval('({'+tp+'})');     
  else table.table_params={};
   

  if(tp=table.getAttribute('table_action_params'))
        table.table_action_params_instance=eval('({'+tp+'})');     
  else  table.table_action_params_instance={};

  var prox={ get(target, prop, receiver) 
            { if(!target[prop]) target[prop]={}; // init on demand
              return target[prop];
            }
           }	
  table.table_action_params = new Proxy(table.table_action_params_instance, prox);


  table_after_open(table);
  
  table_invoke_event(table, "on_table_init", { table: table});    
  
  if(table.classList.contains('paged'))	
   if(table.classList.contains('reverse'))	
         table.parentElement.addEventListener("scroll", function(event) {on_table_reverse_scroll(table);});
   else	 table.parentElement.addEventListener("scroll", function(event) {on_table_direct_scroll(table);});
}


function table_dbform_post(f)
{
 if(!f.reportValidity()) return;
 if(f.method=='post') { f.submit(); return; } 
 
 var xhr = new XMLHttpRequest();
 xhr.open("POST", f.getAttribute('table_data') || f.id+'.php', false); 
 xhr.send(new FormData(f));
 if(xhr.status!=200) 
 { on_table_error(xhr.responseText);
   throw xhr.responseText; 
 }
 f=load_form(f,xhr);
 table_dbform_init(f);
}

function table_dbform_cancel(f)
{ table_invoke_event(f, "on_table_before_cancel");  
  f.reset();
  table_set_class(f, ts_browse)
  table_invoke_event(f, "on_table_after_cancel");  
}

function table_master_select(tr, master, detail)
{ let key=detail.getAttribute('table_master_key');
  if(!key) 
   for(let k in tr.dataset) //first data field as default
   { key=k;
     break;
   }
  
  detail.table_params[detail.getAttribute('table_detail_link') || key] = tr.dataset[key];
  table_reopen(detail);     
}

function table_master_state(st, detail)
{// if(st==ts_edit || st==ts_insert)  table_set_state(detail, ts_disabled);  
}


/*function table_detail_before_insert(master, detail, tr)
{ tr.dataset[detail.getAttribute('table_detail_link')] = master.querySelector(':scope tr.selected').dataset[detail.getAttribute('table_master_key')];
}*/

function table_detail_init(table)
{ var master=document.getElementById(table.getAttribute('table_master'));
  master.addEventListener("on_table_deselect", function(ev) { table_close(table); });
  master.addEventListener("on_table_select",   function(ev) {table_master_select  (ev.detail.row, master, table);});    
  master.addEventListener("on_table_state",    function(ev) {table_master_state   (ev.detail.state, table);});    
  //table.addEventListener("on_table_before_insert", function(ev) {table_detail_before_insert(master, table, ev.detail.row);});  
}

function table_dbform_input()
{ table_set_class(this, ts_edit);}

function table_dbform_init(f)
{ table_set_state(f, ts_browse);  
  f.addEventListener("input", table_dbform_input);
}

//return Uint8Array
function base64_decode(s)
{
  var bin = atob(s);
  var arr = new Uint8Array(bin.length)
  for(var i = 0; i<bin.length; i++) arr[i] = bin.charCodeAt(i);
  return arr;
}

document.addEventListener("DOMContentLoaded", 
   function() { document.querySelectorAll('table.table').forEach(table_init); 
                document.querySelectorAll('table[table_master].table').forEach(table_detail_init); 
				document.querySelectorAll('form.table').forEach(table_dbform_init); 
              }); 