<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_HARDWARE);


new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends GenIntField
    { public $name = 'L_NUM'; 
 	  public $data= true;
	  public $visible=false;
      public $generator='D_GEN_TER_ZONES_LINK';
    },
    new class extends DBLookupField
    { public $name = 'READER'; 
	  public $query= 'select reader,read_name from D_ABSTRACT_READERS order by read_name';
    }
  ];   
    
  $this->select_sql ='select * from D_TER_ZONES_LINK where ter_zone=:ter_zone and reader_type=:type order by l_num';   
  $this->refresh_sql='select * from D_TER_ZONES_LINK where l_num=:l_num';
  $this->delete_sql ='delete from D_TER_ZONES_LINK where l_num=:l_num';
  $this->insert_sql ='insert into D_TER_ZONES_LINK (l_num, reader, ter_zone, reader_type) values(:l_num, :reader, :ter_zone, :type)'; 
 }
 
function before_select($params) 
{
 $this->fn['READER']->caption = ($params['TYPE']==1 ? '' :  '').' ';
}
 
protected $error_map = ['E_APB_ONE_COMPUTER' => "          \r\n     .",
                        'D_TER_ZONES_LINK_UNIQ' => "      "
					   ];  
 
 
 }; //TDataset