<?php
include_once "elacset.php"; 
include_once "colors.php"; 

assert_right(RT_FUNCTIONS, RI_TIMEZONES);


new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'ZONE'; 
      public $caption = '';
 	  public $data= true;
	  public $names= ['update' => 'NEWZONE'];
	  public $min=3;
	  
	  function get_default($action)
	  { return $this->dataset->db->query('select max(ZONE) from D_TIMEZONES')->fetchColumn()+1; }	  
    },
    new class extends StringField
    { public $name = 'Z_NAME';
      public $caption = '';  
  	  public $size=64;	  
	  
      function get_styles($value, $row)  
	  { extract($row);
	    if($zc=zone_color($ZONE, $COLOR, ''))
         	 return ["background: $zc",  'color: black']; 	  
		else return [];  
	  }
	  
    },
    new class extends ColorField
    { public $name = 'COLOR'; 
      public $data= true;
      public $visible  = false; 
 	  public $required = false;
    }	
  ];
  
  $this->select_sql ='select * from D_TIMEZONES '.sql_where("where ZONE",RT_TIMEZONES).' order by zone';   
  $this->refresh_sql='select * from D_TIMEZONES where zone=:zone';
  $this->delete_sql ='delete from D_TIMEZONES where zone=:zone';
  $this->update_sql ='update D_TIMEZONES set zone=:newzone, z_name=:z_name, color=:color where zone=:zone';
  $this->insert_sql ='insert into D_TIMEZONES (zone, z_name, color) values (:zone, :z_name, :color)';    
 }

 
 function get_tr_classes($row)
 { if($row['ZONE']<=2)  return ['row-readonly'];  } 
 
 
 protected $error_map=['D_TIMEZONESPRIMARYKEY' => '    ',
                       'FOREIGN KEY'           => '  ',
					   'E_INVALID_ZONEEDIT'    => '   '
                      ];
					  
 function exec_action($action, $params)
 { 
  $z = $params['ZONE'] ?? $params['NEWZONE'] ?? null;
  if(!is_null($z))
  {  $z=intval($z);
     assert_right(RT_TIMEZONES, $z);      	
     if($z<=2) throw new Exception($this->error_map['E_INVALID_ZONEEDIT']);    
  }
  parent::exec_action($action, $params);
 }					  
 
}; 


 