<?php
include_once "elacset.php"; 
include_once "tz_stuff.php"; 

assert_right(RT_FUNCTIONS, RI_TIMEZONES);


new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends GenIntField
    { public $name  = 'PR_KEY'; 
 	  public $data = true;
	  public $generator = 'd_gen_tz_interval';
	  public $visible=false;
    },

    new class extends IntField
    { public $name  = 'ZONE'; 
	  public $visible=false;
    },	
	
    new class extends HourField
    { public $name  = 'H_START';  
	  public $title = '  ';

 	  public $extra_caption = '';
  	  public $extra_colspan = 2;		
    },	
	
    new class extends MinuteField
    { public $name  = 'M_START';  
	  public $title = '  ';
    },	

    new class extends HourField
    { public $name  = 'H_END';  
	  public $title = '  ';
 	  public $max   = 24;
	  
  	  public $extra_caption = '';
  	  public $extra_colspan = 2;		
    },	

    new class extends MinuteField
    { public $name  = 'M_END';  
	  public $title = '  ';
    },	
	
    new class extends BoolField
    { public $name  = 'MON';  
	  public $caption = '';
	  public $title = '';
	  public $default=1;
	  
  	  public $extra_caption = ',   ';
  	  public $extra_colspan = 9;			  
    },	

    new class extends BoolField
    { public $name  = 'TUS';  
	  public $caption = '';
	  public $title = '';
	  public $default=1;
    },	

    new class extends BoolField
    { public $name  = 'WED';  
	  public $caption = '';
	  public $title = '';
	  public $default=1;
    },	
	
    new class extends BoolField
    { public $name  = 'THE';  
	  public $caption = '';
	  public $title = '';
	  public $default=1;
    },	

    new class extends BoolField
    { public $name  = 'FRI';  
	  public $caption = '';
	  public $title = '';
	  public $default=1;
    },	
	
    new class extends BoolField
    { public $name  = 'SAT';  
	  public $caption = '';
	  public $title = '';
    },	
	
    new class extends BoolField
    { public $name  = 'SUN';  
	  public $caption = '';
	  public $title = '';
    },	
	
    new class extends BoolField
    { public $name  = 'HOL1';  
	  public $caption = '';
	  public $title = ' ';
    },	
	
    new class extends BoolField
    { public $name  = 'HOL2';  
	  public $caption = '';
	  public $title = ' ';
	  public $default=1;
    },	
		

    new class extends StringField
    { public $name = 'DESCR';
      public $caption = '';  
      public $size=40;	  
	  public $required=false;
	  
    }
  ];
  
  $this->select_sql = 'select * from D_TIMEZONES_INTERVALS where zone=:zone order by h_start,m_start,h_end,m_end';   
  $this->refresh_sql= 'select * from D_TIMEZONES_INTERVALS where pr_key=:pr_key';
  $this->delete_sql = 'delete   from D_TIMEZONES_INTERVALS where pr_key=:pr_key';
  $this->update_sql = 'update D_TIMEZONES_INTERVALS 
                       set sun = :sun,  mon = :mon,  tus = :tus,  wed = :wed,    the = :the,  fri = :fri,  sat = :sat,   hol1 = :hol1,  
					       hol2 = :hol2,  descr = :descr,  h_start = :h_start,  m_start = :m_start,  h_end = :h_end,  m_end = :m_end
                       where pr_key = :pr_key';
					   
	
  $this->insert_sql ='insert into D_TIMEZONES_INTERVALS 
                                   ( pr_key, zone, sun, mon, tus, wed, the, fri, sat, hol1, hol2, descr, h_start, m_start, h_end, m_end)
                            values (:pr_key,:zone,:sun,:mon,:tus,:wed,:the,:fri,:sat,:hol1,:hol2,:descr,:h_start,:m_start,:h_end,:m_end)';    
 }

 protected $error_map=['E_INVALID_ZONEEDIT' => '  '];

 
 function exec_action($action, $params)
 {
  switch($action)
  { case 'select':  case 'insert':  
          $z=intval($params['ZONE']); 
		  break;
    case 'update':  case 'delete': case 'edit': case 'refresh':
          $z=$this->db->query('select zone from D_TIMEZONES_INTERVALS where pr_key = '.intval($params['PR_KEY']))->fetchColumn();   
	      break;   		   
  }
 
 if(isset($z)) 
 { assert_right(RT_TIMEZONES, $z);      	
   if($action!='select' && $z<=2) throw new Exception($this->error_map['E_INVALID_ZONEEDIT']);    
 }
 
  parent::exec_action($action, $params);
 }
 
}; 
 