<?php
include_once "elacset.php"; 
assert_right(RT_FUNCTIONS, RI_USERS); 


new class extends TDataset
{
 protected $autorun=false;

 function init()
 {
 
  $this->fields=
  [
    new class extends IntField
    { public $name = 'NUM'; 
 	  public $data= true;
	  public $visible=false;	
    },

    new class extends StringField
    { public $name = 'USERNAME';
      public $caption = '';  
    },
	
    new class extends StringField
    { public $name = 'GROUPNAME';
      public $caption = '';  
    }		
  ];	 
 
 
  $this->select_sql= 
 'select u.num, u.username, g.groupname from USERS u
  left join D_OWNERS o on u.num=o.user_ref
  left join DW_USER_STATES s on u.num=s.user_ref and s.workflow=0
  left join GROUPS g on u.usergroup=g.num
  where o.user_ref is null '.sql_where(" and u.usergroup",RT_GROUPS);        
 
  $this->delete_sql = 'delete from users where num=:num';   
 }
 
 function before_select($params)
 { 
   if(!empty($params['GROUP'])) $this->select_sql.=" and u.usergroup=:group";
   $this->select_sql.=' and s.state'.($params['STATE']=='' ? ' is null' : '=:state');   
   $this->select_sql.=' order by u.username';
 } 
 
 function before_delete($params)
 {
   assert_right(RT_USERPROPS,RU_ADD_DELETE);
   assert_right(RT_GROUPS, $this->prepare_execute('select usergroup from USERS where num=:num', $params)->fetchColumn());
 }   
};