<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_USERS);

function assert_group($user_ref)
{ global $db;
  if(right_restricted(RT_GROUPS))  
    assert_right(RT_GROUPS, $db->query("select usergroup from USERS where num=$user_ref")->fetchColumn());  		
}


new class extends TDataset
{
 function init()
 {
  $this->fields=
  [ 
    new class extends GenIntField
    { public $name = 'ID'; 
 	  public $data= true;
	  public $visible=false;
	  public $generator='D_GEN_DEFERRED_LEVELS';
	  
 	  function restrict($id, $action)
	  { $row=$this->dataset->db->query("select * from D_DEFERRED_LEVELS where id=$id")->fetch(PDO::FETCH_ASSOC);  
 		if($row['REALIZED']) throw new Exception('  ');
        assert_right(RT_LEVELS,$row['ACC_LEV']);
        assert_group($row['USER_REF']);
		assert_right(RT_USERPROPS, RU_LEVEL); 
	  }	  	  
    },  
	
    new class extends IntField
    { public $name = 'USER_REF'; 
	  public $visible=false;
	  
	  function restrict($v, $action)
	  { assert_group($v); }	  
    },  	
	
    new class extends DateTimeField
    { public $name = 'DATETIME'; 
   	  public $caption = '-'; 
	  
      public $format='d.m.y H:i'; 
	  public $format_zero='d.m.y'; 
	  
 	  function get_default($action)	 			  
	  {  return $this->dataset->db->query('select cast("today" as date)+1 from rdb$database')->fetchColumn();	  }   
  
    },  	
    new class extends DBLookupField
    { public $name = 'ACC_LEV'; 
   	  public $caption = ' '; 
      public $query = 'select a_level,a_name from D_ACCESS_LEVELS order by a_name';	  
	  
	  
 	  function restrict($v, $action)
	  { assert_right(RT_USERPROPS, RU_LEVEL); 
	    assert_right(RT_LEVELS,$v); 
      } 	
    }  		
  ];
  
  $this->select_sql = 'select * from D_DEFERRED_LEVELS where user_ref=:user_ref order by datetime';     
  $this->refresh_sql= 'select * from D_DEFERRED_LEVELS where id=:id';
  $this->delete_sql = 'delete from D_DEFERRED_LEVELS where id=:id';
  $this->insert_sql = 'insert into D_DEFERRED_LEVELS (id, user_ref, acc_lev,  datetime) values(:id, :user_ref, :acc_lev, :datetime)'; 
  $this->update_sql = 'update D_DEFERRED_LEVELS set  acc_lev = :acc_lev, datetime = :datetime where id = :id';    
   
 } 
 
 function get_tr_classes($row)  
 { if($row['REALIZED'] || !has_right(RT_LEVELS,$row['ACC_LEV'])) 
     return ['row-readonly']; 
 }
 

};