<?php
include_once "elacset.php"; 
include_once "colors.php"; 
include_once "options.php"; 
include_once 'photonorm.php';
include_once 'cardcode.php';

assert_right(RT_FUNCTIONS, RI_USERS);

class ExCardCode extends CardCodeField
{  public $table_name; 
   public $card_type; 
}

class ExTabField extends IntField
{ public $table_name;
  public $card_type;
}
   
class ExO_NUMBERField extends O_NUMBERField
{ public $table_name; 
  public $card_type; 
}

class PropStringField extends StringField
{ public $prop_id;
  public $right;
}


$TableU = new class extends TDataset
{
 protected $autorun=false; 
 protected $autosort=true; 
 protected $defsort = 'USERNAME';
 
 //   
 private $default_visible='USERNAME,GROUPNAME,ACC_LEV_NAME,CARD_CODE,COLOR,ACT_DATE,DAS_DATE,OWNERACTIVE,PHOTO_EXIST';
 private $fields_option;
 private $fields_sid;


 private $ptables='';
 private $pfields='';
 
 
 function init()
 {   
  $this->fields_option=new d_editor_option('web/users_fields');
  $this->fields_sid   =new d_sid_option('users_fields');
  
  $this->fields=
  [
    new class extends IntField
    { public $name = 'NUM'; 
 	  public $data= true;
      public $required=false;	
	  
	  function restrict($v, $action)
	  { if(right_restricted(RT_GROUPS))  
         assert_right(RT_GROUPS, $this->dataset->prepare_execute('select usergroup from USERS where num=:num', $params)->fetchColumn());  
	  }
    },

    new class extends StringField
    { public $name = 'USERNAME';
      public $caption = '';  
	  public $title =   ' ';
  	  public $size=64;	  
	  public $USERS=true;
	  public $right=RU_NAME;
    },
	
    new class extends IntField
    { public $name = 'ACC_LEV'; 
      public $D_OWNERS=true;
	  public $right=RU_LEVEL;
	  
 	  function validate_also($v)
	  { assert_right(RT_LEVELS, $v); }	  
    },
	
    new class extends IntField //. 
    { public $name = 'A_LEVEL'; 
	  public $right=RU_LEVEL;
      public $required=false;	
	  
      function validate_also($v)	  
	  {  foreach($v as $id=>$val)
     	 { assert_right(RT_LEVELS, $val);
		   if($this->dataset->params['NUM']!=$this->dataset->db->query("select user_ref from D_OWNER_LEVELS where id=$id")->fetchColumn())
            throw new Exception('invalid user');		   
		 }	
   	  }
    },
	
    new class extends IntField //. 
    { public $name = 'A_LEVEL_NEW'; 
	  public $right=RU_LEVEL;
      public $required=false;	

  	  function restrict($v, $action)
	  { assert_right(RT_LEVELS, $v); }	  	
	},
	

    new class extends IntField
    { public $name = 'USERGROUP'; 
	  public $names= ['select' => 'GROUP'];
      public $required=false;	
	  public $USERS=true; 
	  public $right=RU_GROUP; 
	  
	  function restrict($v, $action)
	  { assert_right(RT_GROUPS, $v); }
	  
	  function validate_also($v)
	  { assert_right(RT_GROUPS, $v ?? 0); } //null group is forbidden if restricted
    },	

    new class extends StringField
    { public $name = 'TABEL_NUMBER';
      public $caption = '. ';  
	  public $title =   ' ';
  	  public $size=64;	  
      public $required=false;
	  public $USERS=true;
	  public $right=RU_TABNUMBER;

	  
      function get_sort_expr($dir)
      { return "CHAR_LENGTH($this->name) $dir, $this->name $dir"; }  	  	  
    },
    new class extends StringField
    { public $name = 'GROUPNAME';
      public $caption = '';  

      function get_sort_expr($dir)
      { return parent::get_sort_expr($dir).', USERNAME'; }  	  	  
    },	
    new class extends StringField
    { public $name = 'ACC_LEV_NAME';
      public $caption = ' ';  
      public $required=false;	
      function get_sort_expr($dir)
      { return parent::get_sort_expr($dir).', USERNAME'; }  	  	  	  
    },	
    new class extends StringField
    { public $name = 'LEVELS_STR';
      public $caption = '.  ';  
	  public $title =   '  ';
      public $required=false;	
      function get_sort_expr($dir)
      { return parent::get_sort_expr($dir).', USERNAME'; }  	  	  
    }];
		
	if(has_right(RT_USERPROPS,RU_CARD))
	{		
     array_push($this->fields,
     new class extends IntField
     { public $name = 'TAB_NUMBER'; 
       public $caption = ' ';
       public $required=false;	  
	   public $D_OWNERS=true;
     },
     new class extends O_NUMBERField
     { public $name = 'O_NUMBER'; 
       public $caption = ' ';
	   public $D_OWNERS=true;
     },
     new class extends CardCodeField
     { public $name = 'CARD_CODE';
       public $caption = ' ';  
	   public $D_OWNERS=true;
     }); 

      //. .  	
	 $this->add_extra_cards();
    }		
   
   array_push($this->fields, 
   
    new class extends ColorField
    { public $name = 'COLOR'; 
	  public $caption = '<wbr>' ;
      public $title = '';	  
      public $required=false;	  
	  public $D_OWNERS=true;
	  public $right=RU_COLOR;
	
      function draw_head_text()  { echo $this->caption;  }
	  
	  function draw($v, $row)
	  {
	   echo "<td class=$this->name";
       if(is_null($v))  echo " title=' '>";        		   
                   else echo " style='background-color: ",html_color($v),"'>"; 
	   echo "</td>";	 
  	  }	  	  

      function get_sort_expr($dir)  { return parent::get_sort_expr($dir).', USERNAME'; }  	  	        
    },

    new class extends DateField
    { public $name = 'ACT_DATE';
      public $caption = ' .';  
	  public $title = ' ';	  
	  public $required=false;	  
	  public $D_OWNERS=true;
	  public $right=RU_PERIOD;
	  function get_sort_expr($dir)  { return parent::get_sort_expr($dir).', USERNAME'; }  	  	  
    },	
	
    new class extends DateField
    { public $name = 'DAS_DATE';
      public $caption = ' .';  
	  public $title = ' ';	  
	  public $required=false;	  
	  public $D_OWNERS=true;
	  public $right=RU_PERIOD;
	  function get_sort_expr($dir)  { return parent::get_sort_expr($dir).', USERNAME'; }  	  	  
    },	

    new class extends BoolField
    { public $name = 'OWNERACTIVE'; 
	  public $caption = '<wbr>';
      public $title = '';	  
	  
      function draw_head_text()  { echo $this->caption;  }	  

      function get_sort_expr($dir)  { return parent::get_sort_expr($dir).', USERNAME'; }  	  	  
    },

    new class extends BoolField
    { public $name = 'PHOTO_EXIST'; 
	  public $caption = ' '; 
      public $title   = ' ';	  
	  function get_sort_expr($dir)  { return parent::get_sort_expr($dir).', USERNAME'; }  	  	  
    },

    new class extends TField
    { public $name = 'PHOTO'; 
	  public $caption = ''; 
      public $required=false;	
	  public $USERS=true;  
	  public $right=RU_PHOTO;
	  
	  function draw_text($value, $row)
	  { if($row['PHOTO_EXIST'])
		 echo "<img ", $this->dataset->db->photo_img_src($row['NUM'], $row['PHOTO_UPDATE_TIME']), ">";
		 
	  }
	  
      function get_sort_expr($dir)
      { return 'PHOTO_EXIST '.$dir.', USERNAME'; }  	  
	  
	  
      function parse($v)
      { if($v=='') return null;  
	    $ph=NormalizePhoto(imagecreatefromstring($v));
   	    ob_start();
        imagejpeg($ph);
        return ob_get_clean();	    
	  }  	  
    },	

    new class extends DateField
    { public $name = 'PHOTO_UPDATE_TIME';
      public $caption = ' ';  
 	  function get_sort_expr($dir)  { return parent::get_sort_expr($dir).', USERNAME'; }  	  	  
    },		
	
    new class extends StringField
    { public $name = 'PRIM';
      public $caption = '';  
	  public $required=false;	  
	  public $USERS=true;
	  public $right=RU_PRIM;
 	  function get_sort_expr($dir)  { return parent::get_sort_expr($dir).', USERNAME'; }  	  	  
    },	
	
    new class extends StringField
    { public $name = 'USER_TYPE_NAME';
      public $caption = '';  
	  public $title = ' ';  
 	  function get_sort_expr($dir)  { return parent::get_sort_expr($dir).', USERNAME'; }  	  	  
    }	
  );      
    
  $this->add_props(); //.   
  
  $this->select_sql=
"select u.num,u.username,o.acc_lev,o.tab_number,o.o_number,o.card_code,o.owneractive,o.color,o.act_date,o.das_date,
u.usergroup, u.prim,u.photo_update_time,u.tabel_number, iif(PHOTO is null, 0,1) as PHOTO_EXIST, sn.name as USER_TYPE_NAME,
(select levels_str from d_levels_str(o.user_ref)) as levels_str, l.a_name as ACC_LEV_NAME, g.GROUPNAME $this->pfields 
from USERS u 
 left join DW_USER_STATES ds on ds.workflow=0 and ds.user_ref=u.num 
 left join DW_STATES sn on ds.state=sn.state and sn.workflow=0
 left join GROUPS g on u.usergroup=g.num
 join D_OWNERS o on u.num=o.user_ref 
 join D_ACCESS_LEVELS l on o.acc_lev=l.a_level
 $this->ptables
 ";   
 
 
 $this->refresh_sql = $this->select_sql.' where u.num=:num';
 
 $this->delete_sql = "delete from D_OWNERS where user_ref = :num"; 
 
 //  
 $dbf = strtoupper($this->fields_sid->get() ?? $this->fields_option->get() ?? $this->default_visible); 
 $this->set_visible(explode(',', $dbf)); 
 } //init
 

function before_select($params)
{
 if(isset($params['GROUP']))
       $this->select_sql.="where u.usergroup=:group";
 else  $this->select_sql.=sql_where("where u.usergroup",RT_GROUPS);   
}  
 
 
 function add_props()
 {
  $q=$this->db->query("select * from USER_PROP_TYPES order by id");
  while($pt=$q->fetchObject())
  {
    $id=$pt->ID;
    $this->pfields.=",PT$id.PROP_VALUE as PROP_$id";
    $this->ptables.=" join USER_PROPS PT$id on PT$id.USER_NUM=u.num+0 and PT$id.PROP_ID=$id";
	
	$f=new PropStringField;
	$f->name="PROP_$id";
	$f->prop_id=$id;
	$f->caption=$pt->PROP_NAME;		
	$f->right=$id;
	$this->fields[]=$f;
  }   
 }
 

 function add_extra_cards()
 {
 $q=$this->db->query("select * from d_card_types where card_type!=0 order by card_type"); 
 while($row=$q->fetchObject())
 {
   $mode=$row->MODE;
   $use_num = $row->USE_NUM;
   $ct=$row->CARD_TYPE;
   $this->ptables.=" left join d_owner_cards crd$ct on crd$ct.user_ref=o.user_ref and crd$ct.card_type=$ct";

  //   //   //
   $use_card_code = $mode==0 || $mode==1;
   $use_tab_number= $use_card_code && $use_num;
   $use_o_number  = $mode==0 || $mode==2;
   
   $this->pfields.=",crd$ct.card_code as card_code_$ct";  
   $f=new ExCardCode;   
   $f->table_name='CARD_CODE';
   $f->name=$f->table_name."_$ct";
   $f->card_type=$ct;
   $f->caption =  $row->NAME . ($mode==0 || ($mode==1 && $use_num) ? " " : "");

   $this->fields[]=$f;
   
   if($use_tab_number)
   { $this->pfields.=",crd$ct.tab_number as tab_number_$ct";
     $f=new ExTabField;   
     $f->table_name='TAB_NUMBER';
     $f->name=$f->table_name."_$ct";
     $f->card_type=$ct;
	 $f->caption=$row->NAME." ";
     $f->required=false;	  
	 $this->fields[]=$f;
   }	
   
   if($use_o_number)
   {  $this->pfields.=",crd$ct.o_number as o_number_$ct";
      $f=new ExO_NUMBERField;   
      $f->table_name='O_NUMBER';
      $f->name=$f->table_name."_$ct";
      $f->card_type=$ct;
	  $f->caption=$row->NAME.($mode==0 ? " " : "");
	  $this->fields[]=$f;
   }         
 }
} 
 



function before_delete($params)
{ assert_right(RT_USERPROPS,RU_ADD_DELETE); }


//    (  )
function prepare_values(&$params, $action)
{
foreach($params as $fn=>$fv) //check only exist fields
 if($fld=$this->param2field($fn))
 {
  if(isset($fld->right)) assert_right(RT_USERPROPS, $fld->right);
  if(is_null($fv))
     $params[$fn] = $fv = $fld->get_default($action);
  $fld->validate($fv);
 }
}


function on_update($params)
{ 
$this->prepare_values($params, 'update');
$this->modify_OWNERS($params);
$this->modify_USERS($params);
$this->modify_extra($params);
$this->reload($params, 'update');  
}


function on_insert($params)
{
 foreach($this->fields as $fld)
  if(isset($fld->D_OWNERS) ||
	 !isset($params['NUM']) && isset($fld->USERS)) //create user, fill nulls
   if(!isset($params[$fld->get_name('insert')]))
    $params[$fld->get_name('insert')]=null;

 

 $this->prepare_values($params, 'insert');
 
 if(isset($params['NUM'])) //just update user
 {  $this->modify_USERS($params);
    $ins_wf= !$this->prepare_execute('update DW_USER_STATES set state=0 where user_ref=:num and workflow=0',   $params)->rowCount(); 
 }
 else  //create user
 {  
    $params['NUM'] = $this->db->gen_id('gen_users');
    $this->prepare_execute('insert into USERS (num,username,usergroup,photo,tabel_number,prim)
                            values (:num,:username,:usergroup,:photo,:tabel_number,:prim)', $params);
    $ins_wf=true;
 }

 //create owner
 $this->prepare_execute('insert into D_OWNERS (user_ref, acc_lev, card_code, act_date, das_date, color, o_number, tab_number)
                         values (:num, :acc_lev, :card_code, :act_date, :das_date,  :color, :o_number, :tab_number)', $params);

 if($ins_wf) $this->prepare_execute('insert into DW_USER_STATES (user_ref,workflow,state) values (:num,0,0)', $params); 					 
 $this->modify_extra($params);
 $this->reload($params, 'insert');  
}


function modify_USERS($params)
{
 foreach($params as $fn=>$fv)
   if($fld=$this->param2field($fn))
     if(isset($fld->USERS))
      $this->prepare_execute("update USERS set $fn=:$fn where num = :num",  $params);
}	  

function modify_OWNERS($params)
{
 foreach($params as $fn=>$fv)
  if($fld=$this->param2field($fn))
   if(isset($fld->D_OWNERS))
    $this->prepare_execute("update D_OWNERS set $fn=:$fn where user_ref = :num", $params);   
}	

function modify_extra($params)
{
foreach($params as $fn=>$fv)
 if($fld=$this->param2field($fn))
 {
  if(isset($fld->prop_id))
     $this->prepare_execute("update USER_PROPS set prop_value=:$fn where user_num=:num and prop_id=$fld->prop_id", $params);  
  else
  if($fn=='A_LEVEL_NEW')
  { $id=$this->db->query('select gen_id(D_GEN_OWNER_LEVELS, 1) from rdb$database')->fetchColumn();
    $this->prepare_execute("insert into D_OWNER_LEVELS (id, user_ref, a_level)  values($id, :num, :$fn)", $params);   
  }
  else
  if(isset($fld->card_type))
      {  
	    $q=$this->prepare_execute("update D_OWNER_CARDS set $fld->table_name=:$fn where user_ref=:num and card_type=$fld->card_type", $params);
  	    if($q->rowCount())
              $this->prepare_execute("delete from D_OWNER_CARDS where user_ref=:num and card_type=$fld->card_type and card_code='' and o_number=0 and tab_number is null", $params);			
		else  $this->prepare_execute("insert into D_OWNER_CARDS (user_ref, card_type, $fld->table_name) values (:num, $fld->card_type, :$fn)", $params);						   
      }
  else	     	
  if($fn=='A_LEVEL')
    foreach($fv as $id=>$a_level)  
      if(is_null($a_level)) 
  	          $this->db->exec("delete from D_OWNER_LEVELS where  id = $id");  
        else  $this->db->exec("update D_OWNER_LEVELS set  a_level = $a_level  where  id = $id");	   
 }		
}


function on_fields_restore($params)
{ $this->fields_sid->clear(); }

function on_fields_save($params)
{ 
 $this->fields_option->set(implode(',',array_keys($params['FIELDS'])));
 $this->fields_sid->clear();
}

function on_fields_apply($params)
{ $this->fields_sid->set(implode(',',array_keys($params['FIELDS']))); }

 
};//TableU  