<?php 
include "form.php"; 
include "table.php"; 
include "TNav.php"; 
?>
<link rel="icon" href="img/3.png">
<link rel="stylesheet" href="TButton.css">

<style>
#workarea   {white-space: nowrap;}
#workarea>* {vertical-align: top;} 		


#vm { display: inline-table;
      width: 35ch; }
	  
#actions { width: 27ch;}

#descr	{ max-height: 100%;
          overflow: auto; 
		  white-space: pre-wrap;
        }
		
#descr:empty {display: none}		
	
		
#workarea>div		
        { display: inline-block;
		  background-color: var(--tables-background);
	      border: 1px solid black;
		  border-radius: 4px 4px 0 0;	
		  padding: 0 1ch;
        }
		
#actions>button {margin: 1ch 0;
                 width: 100%;
				 text-align: left;
				}		
	  
#vm button.openfile
{ width: 100%;
  padding: 0;
}	  

#vm button.openfile::after
{  content: url(img/open.png); }


td.ID    {text-align: right; }
col.NAME {width: 100%;}
	  
</style>

<script>
function vm_select(tr)
{ descr.innerHTML='';
  var f=table_row_action(vm, 'description'); 
  if(f.childElementCount)
     descr.appendChild(f);

  update_btns();
}

function update_btns()
{ 
  btnload.disabled  = vm.table_state==ts_browse;
  btnsave.disabled  = !(vm.table_state==ts_selected && table_current_row(vm).querySelector(':scope td.BYTE_CODE input').checked);  
  btnstore.disabled = btnsave.disabled;
}


function vm_store()
{
  table_row_action(vm, 'store'); 
  alert(' ');
}

function vm_save()
{
  let a=table_row_action(vm, 'export').children[0]; 
  let blob=new Blob([base64_decode(a.innerHTML)]);
  a.href = window.URL.createObjectURL(blob);  
  document.createElement('div').appendChild(a);
  a.click();
}


function byte_code_change()
{ if(this.files.length)
    this.closest('tr').querySelector(':scope input[name="name"]').value = this.files[0].name.split('.')[0];
}

function vm_after_new(tr)
{ tr.querySelector(':scope input[name="byte_code"]').onchange = byte_code_change;
}

function vm_load()
{ var tr=table_make_editable(vm);
  tr.querySelector(':scope input[name="byte_code"]').click();
}
</script>


<title> </title>
</head>
<body id=workarea>
<table id=vm class="grid table" 
       table_data="vm_data.php"
  	   on_table_select="vm_select(event.detail.row)"
	   on_table_deselect="descr.innerHTML=''"
	   on_table_after_new="vm_after_new(event.detail.row)"
	   on_table_state="update_btns()"
	   >
<caption class=TNav><? nav_def();?></caption>
<?php include "vm_data.php";?>
</table>

<div id=actions>
<button id=btnstore class=TButton onclick="vm_store()" title="       " disabled><img src="img/run.png"><span>  </span></button><br>
<button id=btnsave  class=TButton onclick="vm_save()"  disabled><img src="img/save.png"><span> bin  </span></button><br>
<button id=btnload  class=TButton onclick="vm_load()"  disabled><img src="img/open.png"><span> bin  </span></button>
</div>

<div id=descr></div>


</body>
</html>  