<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_HARDWARE); 



new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'ID'; 
      public $names = ['update' => 'NEWID'];
	  public $data = true;
 	  public $caption = '';
	  
	  function get_default($action)
	  { return $this->dataset->db->query('select max(ID)+1 from D5_PROGRAMS')->fetchColumn(); }
    },
    new class extends StringField
    { public $name = 'NAME';
      public $size = 64;
	  public $caption = ' ';
	  public $autofocus=true;
    },
    new class extends TField
	{ public $name = 'BYTE_CODE';
      public $caption = 'bin'; 
	  public $title = '  -'; 
	  public $required=false;
      public $td_class=['boolField'];	  
	  
      function draw_text($val, $row)
      { echo "<input type=checkbox";
        if($val) echo ' checked';
        echo '>';
      }
	  
     function draw_editor($val, $row, $action)  
     { 	 
       echo '<td class=inplace>';
	 
	 
	   draw_html_tag('button', ['type' => 'button',
	                            'onclick' => 'this.nextElementSibling.click()',
								'class' => 'openfile'
							   ], '');
	   

	   draw_html_tag('input',  [ 'name' => $this->get_name($action),
                            	 'type' =>'file',	    
                        	     'accept' => '.bin',	  
                              	 'style' => 'display: none'] );
       echo '</td>';
     }	  
	}
  ];	
  
 
  $sel='select id,name, iif(byte_code is null, 0,1) as byte_code from d5_programs';
  $this->select_sql =$sel.' order by id';   
  $this->refresh_sql=$sel.' where id=:id';
 }  
 
public $insert_sql='insert into D5_PROGRAMS( id, name, byte_code)  values( :id, :name, :byte_code)';

public $delete_sql=	'delete from D5_PROGRAMS where id = :id';   

public $update_sql=	'update D5_PROGRAMS set  id = :newid, name = :name @updcode where id = :id';   
			 
					 
function before_update(&$params)
{
 if(isset($params['BYTE_CODE']))
  $params['@updcode']=', byte_code = :byte_code';
}
			
 

 function on_description($params)
 {
   $bc=$this->prepare_execute('select BYTE_CODE from D5_PROGRAMS where id=:id',$params)->fetchColumn();   
   if(!str_ends_with($bc, "\x00\x00\x00\xfd")) return;
   
   $pos=strrpos($bc, "\xfd\x00\x00\x00");
   if($pos===false) return;
   
   echo '<div>', substr($bc, $pos+4, -4), '</div>'; 
 } 

 
 function on_store($params)
 {
   $this->prepare_execute("insert into D_COMMANDS (executor,phis_addr,text) 
                          select computer,adr,'el05_set_program' from D5_DEVICES where program=:id", $params);
 }
 
 function on_export($params)  
 {
   $row=$this->prepare_execute('select NAME, BYTE_CODE from D5_PROGRAMS where id=:id',$params)->fetch();   
   if(!$row[1]) throw new Exception('- ');   
   echo "<a download='$row[0].bin'>",base64_encode($row[1]),'</a>';
 }

 
 protected $error_map=['PRIMARY or UNIQUE KEY' => '    ' ];   
}; 