<?php
include_once "elacset.php"; 
include_once "wm_stuff.php"; 

assert_right(RT_FUNCTIONS, RI_WORK_MODES);

new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name  = 'WORK_MODE'; 
	  public $visible=false;
    },	
	
    new class extends DateTimeField
    { public $name = 'START_DATETIME';
      public $data = true;
	  public $format='d.m.Y H:i'; 
      public $names= ['update' => 'NEW_START_DATETIME'];
      public $caption = '';  	  
    },	

    new class extends DateTimeField
    { public $name = 'END_DATETIME';
      public $caption = '';  
	  public $format='d.m.Y H:i'; 	  
    },	

    new class extends WMModeField
	{ public $name  = 'MODE';  
	}	
  ];
 
   
  $this->select_sql = 'select * from D_WORK_MODES_EXCEPTS where work_mode=:work_mode order by start_datetime';   
  $this->refresh_sql= 'select * from D_WORK_MODES_EXCEPTS where work_mode=:work_mode and start_datetime=:start_datetime'; 
  $this->delete_sql = 'delete from D_WORK_MODES_EXCEPTS where work_mode=:work_mode and start_datetime = :start_datetime';
  $this->update_sql = 'update D_WORK_MODES_EXCEPTS set 
                       start_datetime = :new_start_datetime,
                       end_datetime = :end_datetime,
                       mode = :mode
                       where work_mode = :work_mode  and start_datetime = :start_datetime';			   
	
  $this->insert_sql ='insert into D_WORK_MODES_EXCEPTS (work_mode, start_datetime, end_datetime,  mode)
                      values( :work_mode, :start_datetime,  :end_datetime, :mode )';    
 }
 
 protected $error_map=[' D_WORK_MODES_EXCEPT_CHECK' => '     '];
 
}; 
 