<?php
include_once "elacset.php"; 
include_once "tz_stuff.php"; 
include_once "wm_stuff.php"; 

assert_right(RT_FUNCTIONS, RI_WORK_MODES);


new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends GenIntField
    { public $name  = 'PR_KEY'; 
 	  public $data = true;
	  public $generator = 'd_gen_tz_interval';
	  public $visible=false;
    },

    new class extends IntField
    { public $name  = 'WORK_MODE'; 
	  public $visible=false;
    },	
	
    new class extends HourField
    { public $name  = 'H_START';  
	  public $title = '  ';

 	  public $extra_caption = '';
  	  public $extra_colspan = 2;		
    },	
	
    new class extends MinuteField
    { public $name  = 'M_START';  
	  public $title = '  ';
    },	

    new class extends HourField
    { public $name  = 'H_END';  
	  public $title = '  ';
 	  public $max   = 24;
	  
  	  public $extra_caption = '';
  	  public $extra_colspan = 2;		
    },	

    new class extends MinuteField
    { public $name  = 'M_END';  
	  public $title = '  ';
    },	
	
    new class extends BoolField
    { public $name  = 'MON';  
	  public $caption = '';
	  public $title = '';
	  public $default=1;
	  
  	  public $extra_caption = ',   ';
  	  public $extra_colspan = 9;			  
    },	

    new class extends BoolField
    { public $name  = 'TUS';  
	  public $caption = '';
	  public $title = '';
	  public $default=1;
    },	

    new class extends BoolField
    { public $name  = 'WED';  
	  public $caption = '';
	  public $title = '';
	  public $default=1;
    },	
	
    new class extends BoolField
    { public $name  = 'THE';  
	  public $caption = '';
	  public $title = '';
	  public $default=1;
    },	

    new class extends BoolField
    { public $name  = 'FRI';  
	  public $caption = '';
	  public $title = '';
	  public $default=1;
    },	
	
    new class extends BoolField
    { public $name  = 'SAT';  
	  public $caption = '';
	  public $title = '';
    },	
	
    new class extends BoolField
    { public $name  = 'SUN';  
	  public $caption = '';
	  public $title = '';
    },	
	
    new class extends BoolField
    { public $name  = 'HOL1';  
	  public $caption = '';
	  public $title = ' ';
    },	
	
    new class extends BoolField
    { public $name  = 'HOL2';  
	  public $caption = '';
	  public $title = ' ';
	  public $default=1;
    },	

    new class extends WMModeField
	{ public $name  = 'MODE';  	}		

  ];
  
  $this->select_sql = 'select * from D_WORK_MODES_INTERVALS where work_mode=:work_mode order by pr_key';   
  $this->refresh_sql= 'select * from D_WORK_MODES_INTERVALS where pr_key=:pr_key';
  $this->delete_sql = 'delete   from D_WORK_MODES_INTERVALS where pr_key=:pr_key';
  $this->update_sql = 'update D_WORK_MODES_INTERVALS 
                       set sun = :sun,  mon = :mon,  tus = :tus,  wed = :wed,    the = :the,  fri = :fri,  sat = :sat,   hol1 = :hol1,  
					       hol2 = :hol2, h_start = :h_start,  m_start = :m_start,  h_end = :h_end,  m_end = :m_end, mode=:mode
                       where pr_key = :pr_key';
					   
	
  $this->insert_sql ='insert into D_WORK_MODES_INTERVALS 
                                   ( pr_key, zone, sun, mon, tus, wed, the, fri, sat, hol1, hol2, h_start, m_start, h_end, m_end, mode)
                            values (:pr_key,:zone,:sun,:mon,:tus,:wed,:the,:fri,:sat,:hol1,:hol2,:h_start,:m_start,:h_end,:m_end, :mode)';    
 }
 
}; 
  