<?php
include_once "elacset.php"; 
include_once('devconst.php');

assert_right(RT_FUNCTIONS, RI_WORK_MODES);

new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends LookupField 
	{ public $name  = 'READER';  
      public $data = true;
      public $caption =  '';
	},
    new class extends IntField
	{ public $name  = 'WORK_MODE';  
	  public $visible = false;
	}	
  ];

  $this->select_sql= 'select * from D_ABSTRACT_READERS where work_mode=:work_mode order by read_name';   
  $this->refresh_sql= 'select * from D_ABSTRACT_READERS where reader=:reader'; 
  $this->insert_sql ='update D_ABSTRACT_READERS set  work_mode = :work_mode where reader = :reader';    			  
  $this->delete_sql ='update D_ABSTRACT_READERS set  work_mode = null where reader = :reader';    			  
 }
 
 function fill_list($data)
 { foreach($data as $row)
    $this->fn['READER']->list[$row['READER']] = $row['READ_NAME'];
 }
 
 function before_select($params)
 { $this->fill_list($this->db->query('select reader,read_name from D_ABSTRACT_READERS'));
 }
 
 function before_new($params)
 {
   $q=$this->db->query(
   "select a.reader,a.read_name,a.work_mode, d.reader_type, d.computer, d.adr, d.schit, d.r1_5, d5.mode
    from D_ABSTRACT_READERS a
	join D_DEVICES d on a.reader=d.reader
	left join D5_DEVICES d5 on d.adr=d5.adr and d.computer=d5.computer
	order by d.computer, d.adr, d.schit") ;
   
   $sides=[]; 
	
   $prev=null;
   while($row = $q->fetch(PDO::FETCH_ASSOC))
   {
     if($prev && $prev['COMPUTER']==$row['COMPUTER'] && $prev['ADR']==$row['ADR'])
	       $rt = $prev['READER_TYPE'];
	 else  $rt = $row['READER_TYPE'];
 
   
     if($rt>=3)
	      $s=el05calcside($row['MODE'], $row['SCHIT']);
	 else 
	      if($row['SCHIT']==1 && $prev && $prev['R1_5']==1)
		       $s=1;
		  else $s=0;	
		  
	 $row['SIDE']=$s;	  
	 
	 if(!($prev && $prev['COMPUTER']==$row['COMPUTER'] && $prev['ADR']==$row['ADR'] && $prev['SIDE']==$row['SIDE']))
	   $sides[]=$row; 
	 
	 $prev = $row;
   }   
   $this->fill_list($sides); 
 }
 
/*   "
    select a.READER,a.READ_NAME,a.WORK_MODE,c.NAME as COMP_NAME
    from D_ABSTRACT_READERS a
    join D_DEVICES d on a.reader=d.reader
where  
(d.schit=0 OR 
 (d.schit=1
  and   
  (select r1_5 from d_devices where computer=d.computer and adr=d.adr and schit=0)=1
 )
) 
  where a.work_mode=:work_mode
 order by c.NAME,a.READ_NAME";*/
 
 
}; 
 